// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  1 julio 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//
// AICH AplicacionesInterpolacionCurvilineaHogar
// El archivo dibuja mecates y objetos similares mediante
// interpolacion burda de normales.  Es compatible con POVRay 3.1.
//
// La macro del dibujo principal tiene cuatro parametros.
// #macro AICH_Cuerda( Estilo, ListaPuntos, ListaNormal, BanderaNormalizar ) 
//      Estilo                  : Para seleccionar el tipo de cuerda.
//              Cuatro opciones disponibles.
//                      AICH_EstiloCable       = 10   Diametro 4*L
//                      AICH_EstiloTriple      = 20   Diametro 4*L
//                      AICH_EstiloMecate      = 30   Diametro 8*L
//                      AICH_EstiloMecate2     = 40   Diametro 4*L
//      ListaPuntos             : Dato array de vectores, para ubicar los
//              puntos de control.
//      ListaNormal             : Dato array de las normales correspondientes.
//              Su tamano debe concordar con ListaPuntos.   
//              Las normales deben considerarse como guias, en realidad
//              los resultados no seran las verdaderas normales.
//      BanderaNormalizar       : La macro necesita normales unitarias.
//              Valor "on", modificar Lista Normal para normalizar.
//              Valor "off", asume que ya se encuentran normalizadas.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare AICH_DefaultTexturaMecate
//      Textura a aplicar a los mecates.
// #declare AICH_DefaultTexturaCable
//      Textura para el cable electrico.
// #declare AICH_DefaultTexturaTripleCable
//      Textura para el cable para ropa.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare AICH_TexturaCable                           = texture  { ... }
//      Textura a aplicar al cable electrico.             
// #declare AICH_TexturaTripleCable                     = texture  { ... }
//      Textura a aplicar al cable de ropa.             
// #declare AICH_TexturaMecate                          = texture  { ... }
//      Textura a aplicar a los mecates.             
// #declare AICH_POV3_1                                 = off;
//      Activa compatibilidad con POVRay 3.1., en algunos sistemas
//      se activara automaticamente.
//
// Para colocarlo requiere definir los puntos
// #include "AICH.inc"                       
// #declare ListaPuntos = array [2]
//              { <0,0,0>,<0.1,0,0> }                                    
// #declare ListaNormales = array [2]
//              { <0,1,0>,<0,1,0> }                                    
// object        { AICH_Cuerda( AICH_EstiloMecate, ListaPuntos, ListaNormales, off ) }
//    
// Al usar modificadores.
// #include "AICH.inc"                  
// #include "textures.inc"
// #declare AICH_TexturaMecate  
//      texture         {
//        average texture_map {[0.5 Rust][0.5 AICH_DefaultTexturaMecate]}
//      }                
// #declare ListaPuntos = array [2]
//              { <0,0,0>,<0.1,0,0> }                                    
// #declare ListaNormales = array [2]
//              { <0,1,0>,<0,1,0> }                                    
// object        { AICH_Cuerda( AICH_EstiloMecate, ListaPuntos, ListaNormales, off ) }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "aich.inc"
   
#declare ListaPuntos    = array [4]
  { <0,0,0>, <-1,1,0>*0.1, <-2,1,0>*0.1, <-2,0,0>*0.1 }  
                                                 
#declare ListaNormal   = array [4] 
  { <1,0,0>,<1,1,0>,<0,1,0>,<-1,0,0>}                                                
  
#local FactorAcercamiento       = 4;

union                   {
  object          {   
    AICH_Cuerda( AICH_EstiloMecate, ListaPuntos, ListaNormal, on )
    rotate     -120*z
    translate   -0.200*x
  }                 
  object          {   
    AICH_Cuerda( AICH_EstiloMecate2, ListaPuntos, ListaNormal, on )
    rotate     -120*z
    translate   -0.200*x 
    scale       -x
  }                 
  object          {   
    AICH_Cuerda( AICH_EstiloCable, ListaPuntos, ListaNormal, on )
    rotate     -120*z
    translate   -0.200*x         
    scale       -y
  }                 
  object          {   
    AICH_Cuerda( AICH_EstiloTriple, ListaPuntos, ListaNormal, on )
    rotate     -120*z
    translate   -0.200*x 
    scale       -x                
    scale       -y
  }                 
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z         
} 
