// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  19 agosto 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//
// AUMC AccesoriosUtilesMaquinaCoser
// El archivo dibuja un Prensatelas con Guia de Agujas.  Su objetivo
// es agregarlo a una o varias Maquinas de Coser que se
// disenaran posteriormente.  Es poco flexible, pero permite
// controlar su movimiento.
//
// La macro tiene cuatro parametros.
// #macro AUMC_PrensatelasGuiaAguja( FraccionDescensoAguja,
//         FraccionAscensoPrensatelas, Balanceo, FraccionMovimientoInferior )
//      FraccionDescensoAguja           : Fraccion entre 0 y 1
//                      para bajar la aguja.
//      FraccionAscensoPrensatelas      : Fraccion entre 0 y 1
//                      para subir el prensatelas.  El modelo real
//                      tiene topes en 0, 0.4.  Con presion se llega
//                      al valor de 1.0 pero se devuelve a 0.4 al soltar.
//      Balanceo                        : Vector para aplicar
//                      rotate al Prensatelas Universal inferior.
//      FraccionMovimientoInferior      : Fraccion entre 0 y 1
//                      que desplaza las guias dentadas inferiores hacia Z-.
//
// Las caracteristicas del objeto son:
//      Soportes Superiores     : 45*L en Y ( semicentrados en dicho plano )
//      AlturaMaximaY           : 72.5*L
//      AlturaMinimaY           : -11*L
//      FrenteX                 : -21.5*L..+30L
//      ProfundidadZ            : -16*L..25*L
//      GruesoPlaca             : 1.4*L
// Se supone que la aguja cae desde Y+ con gravedad Y-, y atravieza el origen de
// coordenadas.  La placa se coloca directamente bajo el plano XZ.
// La costurera se sienta hacia Z-, y mira el aparato hacia Z+.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare AUMC_TexturaMetalica
//      Textura principal a aplicar a las estructuras.
// #declare AUMC_TexturaNegra
//      Textura auxiliar para zonas en negro.
// #declare AUMC_TexturaDentada
//      Textura a aplicar a las guias dentadas inferiores.  Los dientes,
//      surgen como efecto visual de la textura.
// #declare AUMC_FraccionPrimerTope
//      Retorna el valor 0.4, que es el tope superior estable permitido
//      en el modelo real para el parametro FraccionAscensoPrensatelas.
//      Permite hasta el valor de 1.0 pero retorna al soltar.  
// #declare AUMC_AlturaGuiaSuperior
//      Altura en Y como real para ubicar los soportes
//      superiores del prensatelas.
// #declare AUMC_VolumenBase
//      Objeto sin textura generado en la macro.  Sirva para perforar
//      superficies y ubicar la base del objeto.  Las coordenadas Y
//      son excesivas a la verdadera placa.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare AUMC_DefaultTexturaMetalica                 = texture  { ... }
//      Textura principal a aplicar a las estructuras.             
// #declare AUMC_DefaultTexturaNegra                    = texture  { ... }
//      Textura auxiliar para zonas en negro.
// #declare AUMC_DefaultTexturaDentada                  = texture  { ... }
//      Textura a aplicar a las guias dentadas inferiores.  Los dientes,
//      surgen como efecto visual de la textura.
// #declare AUMC_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
//
// Para colocarlo simplemente
// #include "AUMC.inc"
// object        { AUMC_PrensatelasGuiaAguja( 0,0,0,0 ) }
//
// Otro ejemplo con modificador
// #include "AUMC.inc"
// #declare AUMC_DefaultTexturaMetalica        = texture       {
//   average
//   texture_map        {
//     [ 0.5 AUMC_TexturaMetalica ]
//     [ 0.5 Rust                 ]
//   }
// }
// object        {
//   AUMC_PrensatelasGuiaAguja( 0,0,0,0 )
// }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}
   
#include "AUMC.inc"

#local FactorAcercamiento       = 22;
object                  {
  AUMC_PrensatelasGuiaAguja(0.1,1,0,0)
  translate     -0.020*y
  rotate        90*y
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z         

}




