// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 11 noviembre 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//                      
// BVPP BarcoVeleroParaPiscina
// El archivo dibuja un barco velero, basada en un juguete
// a control remoto.  Se modifico ligeramente, para mejorar su apariencia
// y poderlo exhibir en escenas de mayor realismo.  Aunque probablemente
// falle en el acercamiento.
// Incluye macro para modificar texturas.  Es compatible con POVRay 3.1.
//      
// La siguiente macro dibuja el objeto default: 
// #macro BVPP_Barco()    
//                                             
// Las dimensiones del objetos default son :  
//      Minimo                  : <-9.75, -3.3,-2.35>
//      Maximo                  : <+9.00, 22.5,+2.35>  
// En el plano XY se encuentra la base de baranda.
// El verdero piso se encuentra por debajo del plano. 
// 
// La siguiente macro permite modificar las texturas facilmente:                               
// #macro BVPP_BarcoVeleroParaPiscina(
//      MaterialCasco, MaterialCabina, MaterialBorde, MaterialPiso,
//      MaterialVentanas, MaterialBaranda,   MaterialMastil,
//      MaterialVelaPosterior, MaterialVelaDelantera, MaterialVelaMedia,
//      MaterialBandera, MaterialMetalizado, MaterialGrada )
//              MaterialCasco           : Material a aplicar al casco.
//              MaterialCabina          : Material principal de cabina.
//              MaterialBorde           : Material para el borde.
//              MaterialPiso            : Material para el piso.
//              MaterialVentanas        : Material para ventanas.
//              MaterialBaranda         : Material para barandas.
//              MaterialMastil          : Material para el mastil.
//              MaterialVelaPosterior   : Material de vela posterior.
//              MaterialVelaDelantera   : Material de vela delantera.
//              MaterialVelaMedia       : Material de vela media.
//              MaterialBandera         : Material de bandera.
//              MaterialMetalizado      : Material de zonas metalicas.
//              MaterialGrada           : Material para gradas.                                                         
//                                                          
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse.
// #declare BVPP_DefaultMaterialCasco           
//      Material a aplicar al casco.
// #declare BVPP_DefaultMaterialCabina          
//      Material principal de cabina.
// #declare BVPP_DefaultMaterialBorde           
//      Material para el borde.
// #declare BVPP_DefaultMaterialPiso            
//      Material para el piso.
// #declare BVPP_DefaultMaterialVentanas        
//      Material para ventanas.
// #declare BVPP_DefaultMaterialBaranda         
//      Material para barandas.
// #declare BVPP_DefaultMaterialMastil          
//      Material para el mastil.
// #declare BVPP_DefaultMaterialVelaPosterior   
//      Material de vela posterior.
// #declare BVPP_DefaultMaterialVelaDelantera   
//      Material de vela delantera.
// #declare BVPP_DefaultMaterialVelaMedia       
//      Material de vela media.
// #declare BVPP_DefaultMaterialBandera         
//      Material de bandera.
// #declare BVPP_MaterialMetalizado      
//      Material de zonas metalicas.
// #declare BVPP_MaterialGrada           
//      Material para gradas.                                                         
//   
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare BVPP_MaterialCasco                          = material { ... }        
//      Material a aplicar al casco.
// #declare BVPP_MaterialCabina                         = material { ... }          
//      Material principal de cabina.
// #declare BVPP_MaterialBorde                          = material { ... }          
//      Material para el borde.
// #declare BVPP_DefaultMaterialPiso                    = material { ... }            
//      Material para el piso.
// #declare BVPP_DefaultMaterialVentanas                = material { ... }       
//      Material para ventanas.
// #declare BVPP_DefaultMaterialBaranda                 = material { ... } 
//      Material para barandas.
// #declare BVPP_DefaultMaterialMastil                  = material { ... }
//      Material para el mastil.
// #declare BVPP_DefaultMaterialVelaPosterior           = material { ... }
//      Material de vela posterior.
// #declare BVPP_DefaultMaterialVelaDelantera           = material { ... } 
//      Material de vela delantera.
// #declare BVPP_DefaultMaterialVelaMedia               = material { ... }
//      Material de vela media.
// #declare BVPP_DefaultMaterialBandera                 = material { ... }
//      Material de bandera.
// #declare BVPP_MaterialMetalizado                     = material { ... }
//      Material de zonas metalicas.
// #declare BVPP_MaterialGrada                          = material { ... }
//      Material para gradas.
// #declare BVPP_POV3_1                                 = off;
//      Valor "on" activa simplificaciones para lograr
//      compatibilidad con POVRay 3.1.  En algunas versiones se
//      activara automaticamente.
//
// Para colocarlo simplemente
//
// #include "BVPP.inc"
//  object                  {
//    BVPP_Barco( ) 
//  }
//
//  o bien la misma figura con la macro detallada... 
//  #include "BVPP.inc"
//  object                  { 
//    BVPP_BarcoVeleroParaPiscina(  
//      BVPP_MaterialCasco, BVPP_MaterialCabina, BVPP_MaterialBorde, BVPP_MaterialPiso,
//      BVPP_MaterialVentanas, BVPP_MaterialBaranda, BVPP_MaterialMastil,
//      BVPP_MaterialVelaPosterior, BVPP_MaterialVelaDelantera, BVPP_MaterialVelaMedia,
//      BVPP_MaterialBandera, BVPP_MaterialMetalizado, BVPP_MaterialGrada ) 
//  }
//
//  o bien se puede redefinir alguna textura 
//  #include "BVPP.inc"                     
//  #declare BVPP_MaterialCasco = material{ { Texture { PinkAlabaster } } }
//  object                  {                                   
//    BVPP_Barco()
//  }
//

#include "textures.inc" 
#include "woods.inc"  
#include "metals.inc"
#include "stones.inc"


#if ( BVPP_POV3_1 )
  #declare BVPP_DefaultMaterialVentanas =
     material  // BVPP_Negro
     {
       texture          {
         Glass3
       }
     }
#else
  #declare BVPP_DefaultMaterialVentanas =
     material  // BVPP_Negro
     {
       M_Glass3
     }
#end


//  $MRY$: 'BVPP_ColorMastil'

  #declare BVPP_Av1    =
    texture     {
      T_Wood2      
      rotate    90*y
      translate 100*y 
      scale     0.01
    }    
  #declare BVPP_Av2    =
    texture     {  
      pigment   {   
        Blue_Agate
      } 
      normal    {    
        gradient y 
        triangle_wave
        scale    0.1
      }  
      scale     0.1
    }   
  
#declare BVPP_DefaultMaterialBorde     =
  material  {  
    texture     {
      average
      texture_map       { 
        [ 0.55 BVPP_Av1 ]
        [ 0.35 BVPP_Av2 ]
        [ 0.10 Rust ]
      }
    }
  }  

#if ( BVPP_POV3_1 )
  #declare BVPP_DefaultMaterialCasco     =   
    material  {
      texture {
        pigment {
          gradient y
          scale         0.05
          pigment_map        { 
           [ 0.1 Blue_Agate]
           [ 0.1 Blood_Marble scale 200 ]
          }
        }    
        normal {
          gradient y
          scale         0.05
        }
      }
      texture             {
        pigment           { 
          agate
          pigment_map     {  
            [ 0 color Brown transmit 0.8 ]
            [ 1 Clear]
          }
        }
      }  
    }
#else
  #declare BVPP_DefaultMaterialCasco     =   
    material  {
      texture {
        pigment {
          Irregular_Bricks_Ptrn (0.1, 8, 0.5, 0.075)
          pigment_map        { 
           [ 0.1 Blue_Agate]
           [ 0.1 Blood_Marble scale 200 ]
          }
        }    
        normal {
           Irregular_Bricks_Ptrn (0.1, 8, 0.5, 0.075) 2
        }
      }
      texture             {
        pigment           { 
          agate
          pigment_map     {  
            [ 0 color Brown transmit 0.8 ]
            [ 1 Clear]
          }
        }
      }  
    }
#end
                                 
                                 
                                 
#declare BVPP_DefaultMaterialBaranda   =
  material                      { 
    texture                     { 
      agate    
      scale     0.25
      texture_map               {  
        [ 0.5 T_Chrome_1A ]
        [ 1 Rusty_Iron ]
      }  
    }
  } 

#if ( BVPP_POV3_1 )
  #declare BVPP_DefaultMaterialPiso      =
    material                      {
      texture {
          gradient      y
          scale         0.05
          texture_map        { 
           [ 0.1 T_Wood1  ]
           [ 0.1 T_Wood10 scale 0.1 ]
          }                 
          rotate          90*x
          scale           0.02
        }    
    }
#else
  #declare BVPP_DefaultMaterialPiso      =
    material                      {
      texture {
          Irregular_Bricks_Ptrn (0.2, 8, 0.5, 0.075)
          texture_map        { 
           [ 0.1 T_Wood1  ]
           [ 0.1 T_Wood10 scale 0.1 ]
          }                 
          rotate          90*x
          scale           0.02
        }    
    }
#end

#if ( BVPP_POV3_1 )
  #declare BVPP_DefaultMaterialCabina =   
    material              {  
      texture             {
        gradient        y
        scale           0.05
        texture_map       {  
          [ 0.05 T_Stone41 ]
          [ 0.05 T_Stone34 scale 100 ] 
        }  
        scale     0.20
        rotate    25   
      }  
    }
#else
  #declare BVPP_DefaultMaterialCabina =   
    material              {  
      texture             {
        Tiles_Ptrn()  
        texture_map       {  
          [ 0.05 T_Stone41 ]
          [ 0.05 T_Stone34 scale 100 ] 
        }  
        scale     0.20
        rotate    25   
      }  
    }
#end
  
#declare BVPP_DefaultMaterialMetalizado        =
  material              { 
    texture             { 
      T_Silver_1A
      normal            { 
        bumps 1
      }
    }
  }  
  
#declare BVPP_DefaultMaterialGrada            =
  material              {  
    texture                     { 
      T_Wood13
    }
  }     
             
#declare BVPP_DefaultMaterialMastil            =
  material              { 
    texture             { 
      Chrome_Texture
    }     
    
    texture             { 
      T_Crack4
      normal            {
        granite
        scale   0.01 
      }
    finish              { 
      metallic
    }     
      scale     0.01
    }  
  } 

#if ( BVPP_POV3_1 )
  #declare BVPP_DefaultMaterialBandera   =
    material              { 
      texture             {  
        pigment {
           bozo
           color_map {[0,rgb 1][1,blue 0.5]}
        }
      }
    }
#else
  #declare BVPP_DefaultMaterialBandera   =
    material              { 
      texture             {  
        pigment {
           Star_Ptrn(1,5,2)
           color_map {[0,rgb 1][1,blue 0.5]}
        }
      }
    }
#end
     
#declare BVPP_DefaultMaterialVelaPosterior     =
  material              { 
    texture             { 
      pigment           {  
        Candy_Cane
      }
      normal            { 
        ripples
        scale   0.1
      }
    } 
    
    texture             {  
    pigment             {  
      White transmit 0.7
    }      
    normal              {  
      quilted   
      control0 0.9
      control1 0.9
      scale     0.1
    } 
    } 
  }
  
#declare BVPP_DefaultMaterialVelaDelantera     = 
  material              {
    BVPP_DefaultMaterialVelaPosterior  
    rotate      10 
  }  

#declare BVPP_DefaultMaterialVelaMedia         = 
  material              {
    BVPP_DefaultMaterialVelaPosterior 
    rotate      -15
  }               
 
//      
#declare BVPP_MaterialCasco             = 
                material { BVPP_DefaultMaterialCasco            } 
#declare BVPP_MaterialCabina            =
                material { BVPP_DefaultMaterialCabina           } 
#declare BVPP_MaterialBorde             = 
                material { BVPP_DefaultMaterialBorde            } 
#declare BVPP_MaterialPiso              = 
                material { BVPP_DefaultMaterialPiso             } 
#declare BVPP_MaterialVentanas          = 
                material { BVPP_DefaultMaterialVentanas         }
#declare BVPP_MaterialBaranda           =
                material { BVPP_DefaultMaterialBaranda          }
#declare BVPP_MaterialMastil            =
                material { BVPP_DefaultMaterialMastil           }
#declare BVPP_MaterialVelaPosterior     =
                material { BVPP_DefaultMaterialVelaPosterior    }
#declare BVPP_MaterialVelaDelantera     =
                material { BVPP_DefaultMaterialVelaDelantera    }
#declare BVPP_MaterialVelaMedia         =
                material { BVPP_DefaultMaterialVelaMedia        }
#declare BVPP_MaterialBandera           =
                material { BVPP_DefaultMaterialBandera          }
#declare BVPP_MaterialMetalizado        =
                material { BVPP_DefaultMaterialMetalizado       }
#declare BVPP_MaterialGrada             =
                material { BVPP_DefaultMaterialGrada            }                                                               
 
 
//  $MRY$: 'BVPP_Verde'


