// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  15 julio 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//
// LFPL LlaveFrancesaPlomeriaLocal
// El archivo dibuja una llave fracesa pequena,
// proporciona una macro para modificar las caracteristicas principales.
//
// La macro default tiene tres parametros
// #macro LFPL_LlaveFrancesa( MoverGuia, AnguloOscilante, MoverRosca )
//      MoverGuia               : Valor real para abrir y cerrar
//              verticalmente.  Utilice valores positivos.
//      AnguloOscilante         : Vector para oscilar los dientes.
//              Utiliza el cilindro de ajuste como centro.
//      MoverRosca              : Aplica un translate adicional
//              al cuerpo de los dientes como vector.
//
// Las dimensiones de la llave francesa son:
//      Alto total              =   132.0*L
//      Frente                  =   -15.0*L..+17.5*L
//      Profundidad             =    15.0*L
// Se dibuja sobre el plano XZ hemisferio positivo,
// casi centrado en los otros planos.
// Los dientes de la llaven miran hacia X+, gravedad Y-.
//
// La siguiente macro permite mayor flexibilidad:
// #macro LFPL_LlaveFrancesaPlomeriaLocal(
//         MoverGuia, AnguloOscilante, MoverRosca,
//         AltoBase, AltoRosca, DiametroRosca,
//         AltoGuiaVertical, FrenteGuiaVertical,
//         ProfundidadGuiaVertical, GruesoDientes, FrenteDientes,
//         TexturaMetalica, TexturaBrillante, TexturaRosca, TexturaBase )
//      MoverGuia               : Valor real para abrir y cerrar
//              verticalmente.  Utilice valores positivos.
//      AnguloOscilante         : Vector para oscilar los dientes.
//              Utiliza el cilindro de ajuste como centro.
//      MoverRosca              : Aplica un translate adicional
//              al cuerpo de los dientes como vector.
//      AltoBase                : Alto referencia para la base.
//              Default es 120*L.
//      AltoRosca               : Alto del cilindro de ajuste.
//              Default es 7.15*L.
//      DiametroRosca           : Diametro del cilindro de ajuste.
//              Default es 14.3*L.
//      AltoGuiaVertical        : Referencia para el alto Z de la
//              columna guia de los dientes.  Default es 71.5*L.
//      FrenteGuiaVertical      : Referencia para el largo X de la
//              columna guia de los dientes.  Default es 10.7*L.
//      ProfundidadGuiaVertical : Referencia para la profundidad Z
//              de los dientes.  Default es 5.0*L.
//      GruesoDientes           : Grosor de los dientes.
//              Default es 1.19*L.
//      FrenteDientes           : Referencia para el largo X de los dientes.
//              Default es 17.5*L.
//      TexturaMetalica         : Textura principal a aplicar a la columna
//              guia de los dientes.  Default es LFPL_TexturaMetalica.
//      TexturaBrillante        : Textura de los dientes de agarre.
//              Default LFPL_TexturaMetalicaBrillante.
//      TexturaBase             : Textura de la base soporte.
//              Default es LFPF_TexturaBase
//      TexturaRosca            : Textura principal del cilindro de ajuste.
//              Default es LFPL_TexturaRosca
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare LFPL_DefaultTexturaMetalica
//      Textura principal a aplicar a la columna guia de los dientes.
// #declare LFPL_DefaultTexturaMetalicaBrillante
//      Textura de los dientes de agarre.
// #declare LFPL_DefaultTexturaBase
//      Textura de la base soporte.
// #declare LFPL_DefaultTexturaRosca
//      Textura principal del cilindro de ajuste.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare LFPL_TexturaMetalica                = texture  { ... }
//      Textura principal a aplicar a la columna guia de los dientes.
// #declare LFPL_TexturaMetalicaBrillante       = texture  { ... }
//      Textura de los dientes de agarre.
// #declare LFPL_TexturaBase                    = texture  { ... }
//      Textura de la base soporte.
// #declare LFPL_TexturaRosca                   = texture  { ... }
//      Textura principal del cilindro de ajuste.
// #declare LFPL_BanderaMarca                   = on;
//      Si se desactiva con "off" no escribe la marca.
// #declare LFPL_StringMarca                    = "POVRay"
//      Permite cambiar el mensaje de marca.
// #declare LFPL_CorrimientoYMarca              = 0;
//      Desplaza la marca en Y.  Positiva hacia Y+ como real.
// #declare LFPL_BanderaUnidades                = on;
//      Si se desactiva con "off" no escribe las unidades en la columna guia.
// #declare LFPL_StringUnidades                 = "7-LISA"
//      Mensaje para las unidades en la columna guia.
// #declare LFPL_CorrimientoYUnidades           = 0;
//      Desplaza el mensaje de unidades en Y.  Positivo hacia Y+ como real.
// #declare LFPL_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
//
// Para colocarlo simplemente
// #include "LFPL.inc"
// object        { LFPL_LlaveFrancesa( 0, 0, 0 ) }
//
// Otro ejemplo:
// #include "LFPL.inc"
// object        { LFPL_LlaveFrancesa( 0.010, 2*z+10*y, -0.001*x )
//
// Otra textura con modificadores:
// #include "LFPL.inc"
// #declare LFPL_TexturaMetalica        = texture       {
//   average
//   texture_map        {
//     [ 0.5 LFPL_DefaultTexturaMetalica ]
//     [ 0.5 Rust                        ]
//   }
// }
// object        {
//   LFPL_LlaveFrancesa( 0, 0, 0 )
// }
//
// Un ejemplo con la macro detallada
// #include "LFPL.inc"
// object               {
//   LFPL_LlaveFrancesaPlomeriaLocal( 0, 0, 0, 0.120, 0.00715, 0.0143,
//              0.0715, 0.0107, 0.005, 0.0715/60, 0.0175,
//              LFPL_TexturaMetalica, LFPL_TexturaMetalicaBrillante,
//              LFPL_TexturaRosca, LFPL_TexturaBase )
// }
//

#include "metals.inc"
#declare LFPL_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( LFPL_POV3_1 )
    #declare LFPL_POV3_1        = on;
  #end
#else
  #ifndef( LFPL_POV3_1 )
    #declare LFPL_POV3_1        = off;
  #end
#end

#declare LFPL_BanderaMarca      = on;
#declare LFPL_StringMarca       = "POVRay"
#declare LFPL_CorrimientoYMarca = 0;
#declare LFPL_BanderaUnidades   = on;
#declare LFPL_StringUnidades    = "7-LISA"
#declare LFPL_CorrimientoYUnidades      = 0;

#declare LFPL_DefaultTexturaMetalica                   = texture       {
  T_Brass_3B
}

#declare LFPL_TexturaMetalica            = texture       {
  LFPL_DefaultTexturaMetalica
}

#declare LFPL_DefaultTexturaRosca                      = texture       {
  T_Brass_3B
  normal                {
    radial
    frequency           60
  }
}

#declare LFPL_TexturaRosca               = texture       {
  LFPL_DefaultTexturaRosca
}

#declare LFPL_DefaultTexturaBase                       = texture       {
  pigment               {
    Red
  }
  normal                {
    granite
  }
}

#declare LFPL_TexturaBase                = texture       {
  LFPL_DefaultTexturaBase
}

#declare LFPL_DefaultTexturaMetalicaBrillante          = texture       {
  T_Brass_1B
}

#declare LFPL_TexturaMetalicaBrillante   = texture       {
  LFPL_DefaultTexturaMetalicaBrillante
}

#macro LFPL_GuiaVertical( RadioMayor, RadioMenor, Vertical, Profundidad,
            FraccionDientes, GruesoDientes,
            TexturaMetalica, TexturaBrillante )
  difference                            {
    union                               {
      difference                          {
        cylinder                          {
          -Profundidad*z, Profundidad*z, RadioMayor
        }
        cylinder                          {
          -1.1*Profundidad*z, 1.1*Profundidad*z, RadioMenor
        }
        plane                             {
          y, 0
        }
        translate               Vertical/2*y
      }
      difference                          {
        cylinder                          {
          -Profundidad*z, Profundidad*z, RadioMayor
        }
        cylinder                          {
          -1.1*Profundidad*z, 1.1*Profundidad*z, RadioMenor
        }
        plane                             {
          y, 0
        }
        translate               Vertical/2*y
        rotate                  180*z
      }
      box                               {
        <-RadioMayor,-Vertical/2,-Profundidad>,
        <-RadioMenor,+Vertical/2,+Profundidad>
      }
      box                               {
        <+RadioMayor,-Vertical/2,-Profundidad>,
        <+RadioMenor,+Vertical/2,+Profundidad>
      }
      #local C                          = 0;
      #local TotDientes                 =
                0.5*( FraccionDientes*Vertical )/GruesoDientes;

      #while ( C < TotDientes )
        #local C                        = C+1;
        box                             {
          <0,0,-Profundidad>,
          <GruesoDientes, GruesoDientes, +Profundidad >
          rotate        -10*x
          translate     RadioMayor*x-Vertical/2*y+2*C*GruesoDientes*y
        }
        box                             {
          <0,0,-Profundidad>,
          <-GruesoDientes, -GruesoDientes, +Profundidad >
          rotate        +10*x
          translate     -RadioMayor*x-Vertical/2*y+2*C*GruesoDientes*y
        }
      #end
      texture                           {
        TexturaMetalica
      }
    }
    plane                               {
      z, 0
      translate         -Profundidad/2*z
      texture                           {
        TexturaBrillante
      }
    }
    plane                               {
      -z, 0
      translate         Profundidad/2*z
      texture                           {
        TexturaBrillante
      }
    }
  }
#end  // #macro LFPL_GuiaVertical

#macro LFPL_DientesSuperiores(
  FrenteDientes, AltoDientes, ProfundidadDientes, GruesoDientes,
  TexturaMetalica, TexturaDientes, BanderaInferior )
union                   {
  union                 {
    box                 {
      <0,GruesoDientes,-ProfundidadDientes/2>,
      <FrenteDientes,AltoDientes,+ProfundidadDientes/2>
    }
    box                 {
      <0,0,-ProfundidadDientes/2>,
      <2*GruesoDientes,AltoDientes,+ProfundidadDientes/2>
    }
    difference          {
      cylinder          {
        -ProfundidadDientes/2*z, +ProfundidadDientes/2*z,
        AltoDientes/2
        translate       AltoDientes/2*y
      }
      plane             {
        -x, 0
      }
    }
    #local C            = 2;
    #local TotDientes   = FrenteDientes/GruesoDientes;
    #while ( C < TotDientes )
      #local GD         = GruesoDientes/sqrt( 2 );
      box               {
        < -GD, -GD, -ProfundidadDientes >/2,
        < +GD, +GD, +ProfundidadDientes >/2
        rotate          45*z
        translate       GruesoDientes*y+GruesoDientes*C*x
      }
      #local C          = C+1;
    #end
  }
  #if ( BanderaInferior )
    box                 {
      < 0, AltoDientes, -ProfundidadDientes/6>,
      < FrenteDientes, 2*AltoDientes, +ProfundidadDientes/6>
      texture             {
        TexturaMetalica
      }
    }
    cylinder            {
      -0.600*ProfundidadDientes*z, +0.600*ProfundidadDientes*z,
      AltoDientes*0.15
      translate         0.20*FrenteDientes*x
                        +1.60*AltoDientes*y
    }
    #local C            = 0;
    #while ( C < 2 )
      difference          {
        sphere            {
          0, 0.25*AltoDientes
          scale   <1,1,0.5>
        }
        plane             {
          -z, 0
        }
        translate         0.20*FrenteDientes*x
                        +1.60*AltoDientes*y
        translate         -0.600*ProfundidadDientes*z
        #if ( C = 1 )
          scale         <1,1,-1>
        #end
      }
      #local C          = C+1;
    #end
  #else
    difference            {
      superellipsoid        {
        <1.0,0.05>
        scale       <FrenteDientes,AltoDientes,ProfundidadDientes>/2
      }
      plane               {
        y,0
      }
      translate   FrenteDientes/2*x+AltoDientes*y
      texture             {
        TexturaMetalica
      }
    }
  #end
  texture               {
    TexturaDientes
  }
}
#end

#macro LFPL_LlaveFrancesaPlomeriaLocal(
       MoverGuia, AnguloOscilante, MoverRosca,
       AltoBase, AltoRosca, DiametroRosca,
       AltoGuiaVertical, FrenteGuiaVertical,
       ProfundidadGuiaVertical, GruesoDientes, FrenteDientes,
       TexturaMetalica, TexturaBrillante, TexturaRosca, TexturaBase )
  union                 {
    // GuiaVerticalTotal
    union               {
      #local RadioGuiaMayor     = ( FrenteGuiaVertical-2*GruesoDientes )/2;
      #local VerticalGuiaMayor  = AltoGuiaVertical*0.625;
      #local AltoDientes        = 0.24*FrenteDientes;
      #local AltoTotalDientes   = 3*AltoDientes;
      #local ProfundidadDientes = 2*ProfundidadGuiaVertical;
      object            {
        LFPL_GuiaVertical(
          RadioGuiaMayor, RadioGuiaMayor-1.5*GruesoDientes,
          VerticalGuiaMayor, ProfundidadGuiaVertical, 0.85,
          GruesoDientes, TexturaMetalica, TexturaBrillante )
        translate       -FrenteGuiaVertical/2*x
        translate       +VerticalGuiaMayor/2*y+FrenteGuiaVertical/2*y
        translate       -( AltoGuiaVertical-AltoTotalDientes )*y
      }
      cylinder          {
        AltoDientes*y, -( AltoGuiaVertical-AltoTotalDientes
         -RadioGuiaMayor-0.90*VerticalGuiaMayor )*y,
        1
        scale           < GruesoDientes, 1, ProfundidadGuiaVertical/2 >
        translate       -( FrenteGuiaVertical-GruesoDientes )*x
      }
      cylinder          {
        AltoDientes*y, -( AltoGuiaVertical-AltoTotalDientes
         -RadioGuiaMayor-0.90*VerticalGuiaMayor )*y,
        1
        scale           < GruesoDientes, 1, ProfundidadGuiaVertical/2 >
        translate       -GruesoDientes*x
      }
      difference        {
        box             {
          <-FrenteGuiaVertical+GruesoDientes,
         -AltoGuiaVertical+AltoTotalDientes+RadioGuiaMayor+VerticalGuiaMayor,
           -0.99*0.5*ProfundidadGuiaVertical >,
          <-GruesoDientes,+AltoDientes,
           +0.99*0.5*ProfundidadGuiaVertical >
        }
        cylinder        {
          -ProfundidadGuiaVertical*z,
          +ProfundidadGuiaVertical*z,
          RadioGuiaMayor
          translate     -FrenteGuiaVertical/2*x
            -( AltoGuiaVertical-AltoTotalDientes-RadioGuiaMayor-
                  VerticalGuiaMayor )*y
        }
      }
      // Interior dientes guia vertical
      box               {
        <-FrenteGuiaVertical+GruesoDientes,
         -AltoGuiaVertical+AltoTotalDientes+RadioGuiaMayor+GruesoDientes,
         -0.4*ProfundidadGuiaVertical >,
        <-GruesoDientes,0,+0.4*ProfundidadGuiaVertical>
      }
      #if ( LFPL_BanderaUnidades )
        text              {
          ttf "timrom.ttf" LFPL_StringUnidades 1,0
          scale         <2,1.5,1>*RadioGuiaMayor-1.500*GruesoDientes
          rotate                90*z
          translate             -1.25*AltoGuiaVertical/2*y
                                -0.45*ProfundidadGuiaVertical*z
                                -0.75*FrenteGuiaVertical/2*x
          translate             +LFPL_CorrimientoYUnidades*y
          texture  { TexturaBrillante }
        }
        text              {
          ttf "timrom.ttf" LFPL_StringUnidades 1,0
          scale         <2,1.5,1>*RadioGuiaMayor-1.500*GruesoDientes
          rotate                90*z
          translate             -1.25*AltoGuiaVertical/2*y
                                -0.45*ProfundidadGuiaVertical*z
                                +1.25*FrenteGuiaVertical/2*x
          scale                 <-1,1,-1>
          translate             +LFPL_CorrimientoYUnidades*y
          texture  { TexturaBrillante }
        }
      #end
      difference        {
        torus           {
          RadioGuiaMayor, GruesoDientes
          rotate        90*x
          scale         0.5*ProfundidadGuiaVertical/GruesoDientes*z
        }
        plane           {
          -y, 0
        }
        translate       -FrenteGuiaVertical/2*x
        translate       -( AltoGuiaVertical-AltoTotalDientes-
                           RadioGuiaMayor-GruesoDientes )*y
      }
      cylinder        {
        -0.4*ProfundidadGuiaVertical*z,
        +0.4*ProfundidadGuiaVertical*z,
        RadioGuiaMayor
        translate     -FrenteGuiaVertical/2*x
              -( AltoGuiaVertical-AltoTotalDientes-RadioGuiaMayor-
                VerticalGuiaMayor-GruesoDientes )*y
      }
      cylinder        {
        -0.4*ProfundidadGuiaVertical*z,
        +0.4*ProfundidadGuiaVertical*z,
        RadioGuiaMayor
        translate     -FrenteGuiaVertical/2*x
              -( AltoGuiaVertical-AltoTotalDientes
                -RadioGuiaMayor-GruesoDientes )*y
      }
      
      difference        {
        superellipsoid  {
          <1.0,0.4>
          scale
                < FrenteDientes+FrenteGuiaVertical,
                  4*AltoDientes, ProfundidadGuiaVertical >/2
        }
        plane           {
          y, 0
        }
        translate       AltoDientes*y
        translate       FrenteDientes/2*x-FrenteGuiaVertical/2*x
      }
      object            {
        LFPL_DientesSuperiores( FrenteDientes, AltoDientes,
          2*ProfundidadGuiaVertical, GruesoDientes,
          TexturaMetalica, TexturaBrillante, off )
      }
      translate       +FrenteGuiaVertical/2*x
      translate       +0.40*AltoGuiaVertical*y-
                      AltoTotalDientes*y
      rotate            AnguloOscilante
      translate       -FrenteGuiaVertical/2*x
      translate       -0.40*AltoGuiaVertical*y+
                      AltoTotalDientes*y
      translate         MoverGuia*y+MoverRosca
      texture           {
        TexturaMetalica
      }
    }
    // EstructuraInferior
    union               {
      difference        {
        object            {
          LFPL_DientesSuperiores( FrenteDientes, 1.5*AltoDientes,
            2*ProfundidadGuiaVertical, GruesoDientes,
            TexturaMetalica, TexturaBrillante, on )
          scale   -1
          translate       +1.00*FrenteDientes*x
        }
        plane           {
          -x,0
          translate     FrenteDientes*x
        }
        plane           {
          x, 0
          translate     +0.15*FrenteDientes*x
        }
        rotate          -10*z
      }
      difference                {
        union                   {
          intersection          {
            union               {
              superellipsoid    {
                <0.2,0.2>
                scale           <FrenteDientes,0.20*AltoGuiaVertical,
                        1.1*ProfundidadGuiaVertical>
                translate       -0.25*AltoGuiaVertical*y
                rotate          +10*z
              }
              superellipsoid    {
                <0.2,0.2>
                scale           <FrenteDientes/2,0.150*AltoGuiaVertical,
                        1.5*ProfundidadGuiaVertical>
                translate       -0.290*AltoGuiaVertical*y
                                -FrenteDientes/2*x*0.80
              }
            }
            cylinder              {
              FrenteDientes*y, -AltoGuiaVertical*y, FrenteDientes
              rotate              -10*z
            }
            sphere              {
              FrenteDientes*x,2*FrenteDientes
            }
          }
          union                         {
            #local C    = 0;
            #while ( C < 3 )
              difference                  {
                superellipsoid            {
                  <0.4,0.4>
                  scale           <FrenteDientes/3,
                        AltoBase,0.75*ProfundidadGuiaVertical>
                }
                plane                     {
                  -y,0
                  translate       -0.20*AltoGuiaVertical*y
                }
                translate         -FrenteDientes/3*x
                matrix            <1,0,+(C-1)*ProfundidadGuiaVertical/
                        FrenteDientes,0,1,0,0,0,1,0,0,0>
                translate         +2*FrenteDientes/3*x+GruesoDientes*x
              }
              #local C  = C+1;
            #end
          }
        }
        box                     {
          <0.15*FrenteDientes,FrenteDientes,-2*ProfundidadGuiaVertical>,
          <FrenteDientes,-1.5*AltoDientes,+2*ProfundidadGuiaVertical>
          rotate                -10*z
        }
        cylinder        {
          -1.4*AltoRosca/2*y, +1.2*AltoRosca/2*y, 1.25*DiametroRosca/2
          translate       -FrenteGuiaVertical/2*x
          translate       -0.40*AltoGuiaVertical*y+
                      AltoTotalDientes*y
        }
        box             {
          <-DiametroRosca,-1.4*AltoRosca/2,-DiametroRosca>,
          <0,1.2*AltoRosca/2,DiametroRosca>
          translate       -FrenteGuiaVertical/2*x
          translate       -0.40*AltoGuiaVertical*y+
                      AltoTotalDientes*y
        }
        box                 {
          < 0.2*FrenteDientes, +AltoDientes, -1.15*ProfundidadDientes/6>,
          < 2*FrenteDientes, -4*AltoDientes, +1.15*ProfundidadDientes/6>
          rotate                -10*z
        }
        difference              {
          superellipsoid          {
            <0.5,0.5>
            scale                 <FrenteDientes/6,AltoBase/2.30,
                                  ProfundidadGuiaVertical/2>
          }
          #if ( LFPL_BanderaMarca )
            text                    {
              ttf "timrom.ttf" LFPL_StringMarca 1, 0
              scale <2,1,1>*FrenteDientes/5
              rotate              90*z
              translate           -0.50*ProfundidadGuiaVertical/2*z
                                +0.075*FrenteDientes*x
                                -0.10*AltoBase*y
              translate         +LFPL_CorrimientoYMarca*y
            }
          #end
          translate             -1.050*AltoBase/2*y+FrenteDientes/3*x
                                +GruesoDientes*x
                                -ProfundidadGuiaVertical*z
        }
        difference              {
          superellipsoid          {
            <0.5,0.5>
            scale                 <FrenteDientes/6,AltoBase/2.30,
                                  ProfundidadGuiaVertical/2>
          }
          #if ( LFPL_BanderaMarca )
            text                    {
              ttf "timrom.ttf" LFPL_StringMarca 1, 0
              scale <2,1,1>*FrenteDientes/5
              rotate              90*z
              translate           -0.50*ProfundidadGuiaVertical/2*z
                                +0.075*FrenteDientes*x
                                -0.10*AltoBase*y
              translate         +LFPL_CorrimientoYMarca*y
            }
          #end
          scale                 <-1,1,-1>
          translate             -1.050*AltoBase/2*y+FrenteDientes/3*x
                                +GruesoDientes*x
                                +ProfundidadGuiaVertical*z
        }

        cylinder                  {
          -2*FrenteDientes*z, 2*FrenteDientes*z, FrenteDientes/8
          scale         <1,3,1>
          translate
          +FrenteDientes/3*x+GruesoDientes*x
          -AltoBase*y+FrenteDientes/1.5*y
        }
        box             {
          <-FrenteGuiaVertical-GruesoDientes,
            AltoDientes,-0.55*ProfundidadGuiaVertical>,
          <+GruesoDientes,-AltoGuiaVertical,+0.55*ProfundidadGuiaVertical>
        }
        texture                 {
          TexturaBase
        }
      }
    }
    // Rosca
    difference        {
      union           {
        cylinder        {
          -AltoRosca/2*y, +AltoRosca/2*y, 0.95*DiametroRosca/2
        }
        cylinder        {
          -0.9*AltoRosca/2*y, -0.1*AltoRosca/2*y, DiametroRosca/2
          texture     {
            TexturaRosca
            rotate    10
          }
        }
        cylinder        {
          +0.9*AltoRosca/2*y, +0.1*AltoRosca/2*y, DiametroRosca/2
          texture     {
            TexturaRosca
            rotate    -10
          }
        }
      }
      cylinder        {
        -AltoRosca*y, AltoRosca*y,
        RadioGuiaMayor+0.25*GruesoDientes
      }
      texture         {
        TexturaMetalica
      }
      rotate            AnguloOscilante
      translate       -FrenteGuiaVertical/2*x
      translate       -0.40*AltoGuiaVertical*y+
                      AltoTotalDientes*y
      translate         MoverRosca
    }
    translate           AltoBase*y
  }
#end

#macro LFPL_LlaveFrancesa( MoverGuia, AnguloOscilante, MoverRosca )
  object                {
    #local L                            = LFPL_L;
    #local AltoGuiaVertical             = 71.5*L;
    #local FrenteGuiaVertical           = 10.7*L;
    #local ProfundidadGuiaVertical      = 5.0*L;
    #local GruesoDientes                = 71.5*L/60;
    #local FrenteDientes                = 17.5*L;
    #local AltoBase                     = 120*L;
    #local AltoRosca                    = 7.15*L;
    #local DiametroRosca                = 14.3*L;
    LFPL_LlaveFrancesaPlomeriaLocal(
      MoverGuia, AnguloOscilante, MoverRosca,
      AltoBase, AltoRosca, DiametroRosca,
      AltoGuiaVertical, FrenteGuiaVertical,
      ProfundidadGuiaVertical, GruesoDientes, FrenteDientes,
      LFPL_TexturaMetalica, LFPL_TexturaMetalicaBrillante,
      LFPL_TexturaRosca, LFPL_TexturaBase
    )
  }
#end



