// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  1 julio 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//
// LSLE LlavinSeguridadLlaveExclusiva
// El archivo dibuja un Llavin con o sin llave.  Ademas ofrece
// macros para agregar accesorios.  Y permite variar algunas
// de sus caracteristicas basicas, incluyendo texturas.
//
// La macro del dibujo principal tiene un parametro.
// #macro LSLE_Llavin( FraccionBoton )
//      FraccionBoton           : Un valor de cero para pomo sencillo.
//              Negativo para agregar cerrojo, -1 sin giro, hasta -0.01
//              para casi 360 grados.
//              Positivo 1.0 para boton.  Aprieta el boton disminuyendo el valor
//              hasta 0.01.
//
// Para agrega los accesorios puede utilizar las siguentes macros.
// Crea la parte puerta del accesorio para trabar la puerta.
// #macro LSLE_AccesorioPuerta
//              ( FraccionAperturaMayor, FraccionAperturaMenor )
//      FraccionAperturaMayor   : 0.0 para cerrado, 1.0 para abierto.
//      FraccionAperturaMenor   : 0.0 para cerrado, 1.0 para abierto.
//
// Crea la parte pared del accesorio para trabar la puerta.
// #macro LSLE_AccesorioPared( )
//
// Las dimensiones del llavin son:
//      Diametro                :  53*L
//      Profundidad             :  52*L..54*L
// Sobresale casi centrado en el plano XY hacia el hemisferio Z-.
//
// Accesorio de puerta:
//      Profundidad en Z        : -13*L..44*L cerrado
//                                - 1*L..44*L abierto
//      Alto                    :  39*L
//      Ancho                   :  18*L
// Casi centrado en el plano XY.  La region interior a la puerta se ubica
// hacia Z+.  La traba mayor a la izquierda.
//
// Accesorio de pared:
//      Alto                    :  49*L
//      Frente                  : -14*L..10*L
//      Profundidad             :   8*L
// Semicentrado en el plano XY sobresale hacia Z+.
//
// La siguiente macro permite mayor flexibilidad:
// #macro LSLE_LlavinFundamental( GiroPomo, FraccionBoton,
//         RadioBasico, ProfundidadSoporte,
//         RadioColumna, ProfundidadColumna, RadioPomo, RadioBoton,
//         TexturaMetalica, TexturaMetalicaSecundaria, TexturaCerrojo )
//      GiroPomo                : Angulo en grados para girar el pomo.
//      FraccionBoton           : Un valor de cero para pomo sencillo.
//              Negativo para agregar cerrojo, -1 sin giro, hasta -0.01
//              para casi 360 grados.
//              Positivo 1.0 para boton.  Lo aprieta disminuyendo el valor
//              hasta 0.01.
//      RadioBasico             : Radio de la base del pomo.
//              Default es 26.5*L.
//      ProfundidadSoporte      : Referencia para la profundidad Z de base.
//              Default es 10*L.
//      RadioColumna            : Radio columna de soporte del pomo.
//              Default es 10*L.
//      ProfundidadColumna      : Referencia para la profundidad Z de la
//              columna soporte del pomo.  Default es 10.5*L.
//      RadioPomo               : Radio de la esfera del pomo.
//              Default es 19*L.
//      RadioBoton              : Radio de la perilla o cerrojo.
//              Default es 4.07*L.
//      TexturaMetalica         : Textura principal a aplicar al aparato.
//              Default es LSLE_DefaultTexturaMetalica.
//      TexturaMetalicaSecundaria               :
//              Textura para zonas de menor calidad.
//              Default es LSLE_DefaultTexturaMetalicaSecundaria.
//      TexturaCerrojo          : Textura para el cerrojo.
//              Default es LSLE_DefaultTexturaCerrojo.
//          
// Para varias el accesorio de puerta, puede usarse la macro siguiente:
// #macro LSLE_AccesorioPuertaLlaveExclusiva(
//          FraccionAperturaMayor, FraccionAperturaMenor,
//          Alto, Ancho, Grueso, RadioPrincipal,
//          ProfundidadCilindro, RadioTornillo, BanderaTornillo,
//          TexturaMetalica, TexturaCilindro, TexturaTornillo )
//      FraccionAperturaMayor   : 0.0 para cerrado, 1.0 para abierto.
//      FraccionAperturaMenor   : 0.0 para cerrado, 1.0 para abierto.
//      Alto                    : Alto del accesorio en Y.
//              Default es 39*L.
//      Ancho                   : Frente en X del accesorio.
//              Default es 18*L.
//      Grueso                  : Grueso de la placa principal.
//              Default es 1*L.
//      RadioPrincipal          : Radio referencia de la traba de puerta.
//              Default es 6.6*L.
//      ProfundidadCilindro     : Referencia para profundidad Z del cilindro
//              interior.  Default es 21*L.
//      RadioTornillo           : Radio para los cilindros de perforacin de los
//              tornillos.  Default es 2.1*L.
//      BanderaTornillo         : Valor "true" dibuja los tornillos, y valor
//              "false" no los dibuja.               
//      TexturaMetalica         : Textura a aplicar en la placa de puerta.
//              Default es LSLE_DefaultTexturaMetalica.
//      TexturaCilindro         : Textura a aplicar al cilindro interior.
//              Default es LSLS_DefaultTexturaCerrojo.
//      TexturaTornillo         : Textura a aplicar a los tornillos.
//              Default es LSLE_DefaultTexturaTornillo.  
//
// La siguiente macro corresponde al detalle del accesorio de pared.
// #macro LSLE_AccesorioParedLlaveExclusiva(
//          Alto, Ancho, Grueso, Fondo, RadioPrincipal, RadioTornillo,
//          BanderaTornillo, TexturaMetalica, TexturaNegra, TexturaTornillo )
//      Alto                    : Alto del accesorio en Y.  Default es 49*L.
//      Ancho                   : Ancho del accesorio en X.  Default es 20*L.
//      Grueso                  : Grueso de la placa.  Default es 1*L.
//      Fondo                   : Referencia para el fondo Z interior.
//              Default es 7*L.
//      RadioPrincipal          : Radio referencia para la traba correspondiente,
//              en el accesorio para puerta.  Default es 6.6*L.
//      RadioTornillo           : Radio del hueco para tornillo.  Default es 2.1*L.
//      BanderaTornillo         : Valor "true" dibuja los tornillos, y valor
//              "false" no los dibuja.
//      TexturaMetalica         : Textura a aplicar del metal.  
//              Default es LSLE_DefaultTexturaMetalica.                   
//      TexturaNegra            : Textura interior del accesorio de pared.
//              Default es LSLE_DefaultTexturaNegra.
//      TexturaTornillo         : Textura para los tornillos.
//              Default es LSLE_DefaultTexturaTornillo.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare LSLE_TexturaMetalica
//      Textura principal a aplicar a las estructuras.
// #declare LSLE_TexturaMetalicaSecundaria
//      Textura metalica para zonas de menor calidad.
// #declare LSLE_TexturaCerrojo
//      Textura para el cerrojo y el cilindro interior del accesorio de puerta.
// #declare LSLE_TexturaNegra
//      Textura para el compartimiento interno del accesorio de pared.
// #declare LSLE_TexturaTornillo
//      Textura para los tornillos.
// #declare LSLE_DifferenceAccesorioPuerta  
//      Define objeto volumen para aplicar en puerta y ubicar el accesorio de puerta.
// #declare LSLE_DifferenceAccesorioPared
//      Define objeto volumen para aplicar en pared y ubicar el accesorio de pared.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare LSLE_DefaultTexturaMetalica                 = texture  { ... }
//      Textura principal a aplicar a las estructuras.             
// #declare LSLE_DefaultTexturaMetalicaSecundaria       = texture  { ... }
//      Textura metalica para zonas de menor calidad.
// #declare LSLE_DefaultTexturaCerrojo                  = texture  { ... }
//      Textura para el cerrojo y el cilindro interior del accesorio de puerta.
// #declare LSLE_DefaultTexturaNegra                    = texture  { ... }
//      Textura para el compartimiento interno del accesorio de pared.
// #declare LSLE_DefaultTexturaTornillo                 = texture  { ... }
//      Textura para los tornillos.
// #declare LSLE_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
//
// Para colocarlo simplemente
// #include "LSLE.inc"
// object        { LSLE_Llavin( -1 ) }
//
// Otro ejemplo con modificador
// #include "LSLE.inc"
// #declare LSLE_DefaultTexturaMetalica        = texture       {
//   average
//   texture_map        {
//     [ 0.5 LSLE_TexturaMetalica ]
//     [ 0.5 Rust                 ]
//   }
// }
// object        {
//   LSLE_Llavin( 1 )
// }
//
// Un ejemplo con la macro detallada
// #include "LSLE.inc"
// object               {
//   LSLE_LlavinFundamental( 0, 1, 0.0266, 0.010, 0.010, 0.0105, 0.019, 0.00407,
//       LSLE_DefaultTexturaMetalica, LSLE_DefaultTexturaMetalicaSecundaria,
//       LSLE_DefaultTexturaCerrojo ) 
// }
//
#include "metals.inc"
#declare LSLE_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( LSLE_POV3_1 )
    #declare LSLE_POV3_1        = on;
  #end
#else
  #ifndef( LSLE_POV3_1 )
    #declare LSLE_POV3_1        = off;
  #end
#end


#declare LSLE_TexturaMetalica                   = texture       {
  T_Chrome_3B
  normal                {
    bumps
    scale  0.10
  }
}

#declare LSLE_DefaultTexturaMetalica            = texture       {
  LSLE_TexturaMetalica
}

#declare LSLE_TexturaCerrojo                    = texture       {
  T_Brass_1E
}

#declare LSLE_DefaultTexturaCerrojo             = texture       {
  LSLE_TexturaCerrojo
}

#declare LSLE_TexturaMetalicaSecundaria                   = texture       {
  T_Chrome_3B
  normal                {
    bozo
    scale  0.01
  }
}

#declare LSLE_DefaultTexturaMetalicaSecundaria            = texture       {
  LSLE_TexturaMetalicaSecundaria
}

#declare LSLE_TexturaTornillo                   = texture       {
  T_Chrome_3B
  normal                {
    bozo
    scale  0.005
  }
}

#declare LSLE_DefaultTexturaTornillo            = texture       {
  LSLE_TexturaTornillo
}

#declare LSLE_TexturaNegra                   = texture       {
  pigment { Gray30 }
  normal                {
    bumps
    scale  0.10
  }
}

#declare LSLE_DefaultTexturaNegra            = texture       {
  LSLE_TexturaNegra
}

#macro LSLE_Tornillo( Radio, Profundidad, TexturaTornillo )
  difference            {
    cylinder            {
      -0.1*Profundidad*z, 1*Profundidad*z, Radio*1.25
    }
    box                 {
      < -Radio*0.1, -Radio, -0.2*Profundidad >,
      < +Radio*0.1, +Radio, +0.9*Profundidad >
    }
    box                 {
      < -Radio*0.1, -Radio, -0.2*Profundidad >,
      < +Radio*0.1, +Radio, +0.9*Profundidad >
      rotate            90*z
    }    
    texture             {
      TexturaTornillo
    }
  }
#end

#macro LSLE_LlavinFundamental( GiroPomo, FraccionBoton,
    RadioBasico, ProfundidadSoporte,
    RadioColumna, ProfundidadColumna, RadioPomo, RadioBoton,
    TexturaMetalica, TexturaMetalicaSecundaria, TexturaCerrojo )
// FraccionBoton 0 para solo relieve
// FraccionBoton positivo para un boton 1.0 y apretarlo hasta 0.01
// FraccionBoton negativo para hueco de llave -1.0 y girarlo hasta -0.01

  union                         {
    lathe                       {
      5,
      < 1.00, 0.00 >,
      < 1.00, 0.25 >,
      < 0.50, 0.50 >,
      < RadioColumna*1.1/RadioBasico, 1.00 >,
      < RadioColumna/RadioBasico*1.01, 1.00 >
      scale                     < RadioBasico, ProfundidadSoporte,
                                  RadioBasico >
                                  
    }  // lathe
    // mango
    cylinder                  {
      0, ( ProfundidadSoporte+1.1*ProfundidadColumna )*y,
      RadioColumna
      texture                 {
        TexturaMetalicaSecundaria
      }
    }
    // Pomo
    #local RadioExtremo       = 21/38*RadioPomo;
    #local PivoteExtremo      =
           sqrt( RadioPomo*RadioPomo-RadioExtremo*RadioExtremo );
    #local PivoteBoton        =
           sqrt( RadioPomo*RadioPomo-RadioBoton*RadioBoton );
    #if ( FraccionBoton = 0 )    
      #local RadioBoton       = 0;
    #end
    #if ( RadioBoton != 0 )  
      #if ( FraccionBoton >= 0 )
        difference                     {
          union                   {
            cylinder                {
              PivoteExtremo*y, 2*PivoteExtremo*y, RadioBoton
            }
            torus                 {
              0.85*RadioBoton, 0.15*RadioBoton
              translate           2*PivoteExtremo*y
            }
          }
          cylinder                {
            0.7*RadioBoton*z, -0.7*RadioBoton*z,
            0.2*RadioBoton
            translate             2*PivoteExtremo*y
          }
          rotate          -0.05
          translate               ProfundidadSoporte*y
          translate               ProfundidadColumna*y
          translate               FraccionBoton*0.1*PivoteExtremo*y
          translate               -( 1-FraccionBoton )*( RadioPomo-PivoteExtremo )*y
        }
      #else  // #else ( FraccionBoton >= 0 )
        difference                {
          cylinder                {
            PivoteExtremo*y, ( 3.00*PivoteExtremo-PivoteBoton )*y,
            RadioBoton
            
          }
          sphere                  {
            0                     , 0.75*RadioBoton
            translate             ( 3.00*PivoteExtremo-PivoteBoton )*y
            translate             -RadioBoton/3*z+0.45*RadioBoton*y
          }
          prism                   {
            PivoteExtremo, 2*PivoteExtremo, 12,
            <-0.2,-0.9>,
            <0.2,-0.9>,
            <-0.00,-0.60>,
            <-0.00,-0.30>
            <0.30,-0.10>,
            <0.30,0.00>,
            <0.10,0.4>,
            <-0.10,0.4>,
            <0.00,0.00>,
            <0.00,-0.10>,
            <-0.30,-0.30>,
            <-0.30,-0.60>
            scale                 <RadioBoton,1,RadioBoton>
          }
          translate               ProfundidadSoporte*y
          translate               ProfundidadColumna*y
          rotate                  360*y*FraccionBoton
          texture                 {
            TexturaCerrojo
          }
        }  // #difference
      #end   // #else ( FraccionBoton >= 0 )
    #end  // #if ( RadioBoton = 0 )
    difference                  {
      sphere                    {
        PivoteExtremo*y, RadioPomo
        translate                 ProfundidadSoporte*y
        translate                 ProfundidadColumna*y
      }
      #if ( RadioBoton != 0 )
        cylinder                {
          PivoteExtremo*y, 2*PivoteExtremo*y, 1.1*RadioBoton
          translate               ProfundidadSoporte*y
          translate               ProfundidadColumna*y
        }
      #end
      sphere                    {
        2*PivoteExtremo*y, RadioPomo
        translate                 ProfundidadSoporte*y
        translate                 ProfundidadColumna*y
        translate                 PivoteExtremo*y
      }
      sphere                    {
        0*y, RadioPomo
        translate                 ProfundidadSoporte*y
        translate                 ProfundidadColumna*y
        translate                 -PivoteExtremo*y
      }
      texture                   {
        TexturaMetalica
      }
      rotate                    GiroPomo*y
    }  // difference
    torus                       {
      ( RadioExtremo+RadioColumna )/2,
      10*( RadioExtremo-RadioColumna )/2
      translate                 ProfundidadSoporte*y
      translate                 1.0*ProfundidadColumna*y
      texture                   {
        TexturaMetalicaSecundaria
      }
      rotate                    GiroPomo*y
    }
    texture                     {
      TexturaMetalica
    }   
    rotate                      -90*x
  }  // union
#end  // LSLD_LlavinFundamental

#macro LSLE_AccesorioPuertaLlaveExclusiva(
      FraccionAperturaMayor, FraccionAperturaMenor,
      Alto, Ancho, Grueso, RadioPrincipal,
      ProfundidadCilindro, RadioTornillo, BanderaTornillo,
      TexturaMetalica, TexturaCilindro, TexturaTornillo )
  union                         {
    #declare LSLE_DifferenceAccesorioPuerta     =
      union                     {
        box                     {
          <-Ancho/2,-Alto/2,1.05*Grueso>,
          
          <+Ancho/2,+Alto/2,-Grueso>
        }
        cylinder                {
          -2*RadioPrincipal*z, ProfundidadCilindro*z,
          1.10*RadioPrincipal
        }
      }
    difference                  {
      union                       {
        box                         {
          <-Ancho/2,-Alto/2+Grueso,Grueso>,
          <+Ancho/2,+Alto/2-Grueso,0>
        }
        box                         {
          <-Ancho/2+Grueso,-Alto/2,Grueso>,
          <+Ancho/2-Grueso,+Alto/2,0>
        }
        cylinder                    {
          Grueso/2*z, ( Grueso+ProfundidadCilindro )*z,
          1.10*RadioPrincipal
          texture               {
            TexturaCilindro
          }
        }
        #local C                = 0;
        #while ( C < 4 )
          cylinder              {
            0, Grueso*z, 2*Grueso
            translate           +( Alto /2-2*Grueso )*y
            translate           +( Ancho/2-2*Grueso )*x
            #switch ( C )
              #case (3)
                scale           <-1,1,1>
              #break
              #case (2)
                scale           <1,-1,1>
              #break
              #case (1)
                scale           <-1,-1,1>
              #break
              #case (0)
            #end
          }
          #local C              = C+1;
        #end
      }
      cylinder                  {
        -Grueso/2*z, 2*Grueso*z, RadioTornillo
        translate               y*( Alto/2-3*RadioTornillo )
      }
      cylinder                  {
        -Grueso/2*z, 2*Grueso*z, RadioTornillo
        translate               -y*( Alto/2-3*RadioTornillo )
      }
      difference                {
        cylinder                {
          -Grueso/2*z, ProfundidadCilindro*z, 1.05*RadioPrincipal
        }
        plane                   {
          -x, -2/3*RadioPrincipal
        }
      }
      cylinder                  {
        ( ProfundidadCilindro-2*RadioPrincipal )*z,
        -2*RadioPrincipal*z, 1.05*RadioPrincipal/3
        translate               2*RadioPrincipal/3*x
      }
    }
    // traba mayor
    difference                  {
      cylinder                  {
        ( ProfundidadCilindro-2*RadioPrincipal )*z,
        -2*RadioPrincipal*z, RadioPrincipal
      }
      plane                     {
        -x, -2/3*RadioPrincipal
      }
      cylinder                    {
        2*RadioPrincipal*y, -2*RadioPrincipal*y, 2*RadioPrincipal
        translate       RadioPrincipal*x
        inverse
      }
      translate         +0.975*FraccionAperturaMayor*2*RadioPrincipal*z
    }
    // traba menor
    difference                  {
      cylinder                  {
        ( ProfundidadCilindro-2*RadioPrincipal )*z,
        -2*RadioPrincipal*z, RadioPrincipal/3
        translate               2*RadioPrincipal/3*x
      }
      plane                     {
        x, 0.700*RadioPrincipal
      }
      cylinder                    {
        2*RadioPrincipal*y, -2*RadioPrincipal*y, 2*RadioPrincipal
        translate       RadioPrincipal*x
        inverse
      }
      translate         +0.975*FraccionAperturaMenor*2*RadioPrincipal*z
    }
    // tornillos
    #if ( BanderaTornillo )
      object                    {
        LSLE_Tornillo( RadioTornillo, Grueso, LSLE_TexturaMetalica )
        translate               +Alto/2*y
        translate               -3*RadioTornillo*y
        texture                 {
          TexturaTornillo
        }
      }
      object                    {
        LSLE_Tornillo( RadioTornillo, Grueso, LSLE_TexturaMetalica )
        translate               -Alto/2*y
        translate               +3*RadioTornillo*y
        texture                 {
          TexturaTornillo
        }
      }
    #end
    texture                     {
      TexturaMetalica
    }
  }
#end  // LSLE_AccesorioPuertaLlaveExclusiva

#macro LSLE_AccesorioParedLlaveExclusiva(
      Alto, Ancho, Grueso, Fondo, RadioPrincipal, RadioTornillo,
      BanderaTornillo,
      TexturaMetalica, TexturaNegra, TexturaTornillo
    )
  union                        {
    #local AltoCaja            = Alto*20/49;
    #local AnchoCaja           = Ancho*13.5/20;
    #declare LSLE_DifferenceAccesorioPared        =
      union                     {
        box                     {
          < -AnchoCaja/2, -AltoCaja/2, Grueso >,
          < +AnchoCaja/2, +AltoCaja/2, Grueso+Fondo >
        }
        box                     {
          < -Ancho/2, -Alto/2, 2*Grueso >,
          < +Ancho/2, +Alto/2, -Grueso >
        }
      }
    // Metalico
    difference                  {
      box                       {
        < -Ancho/2, -Alto/2, Grueso >,
        < +Ancho/2, +Alto/2, 0 >
      }
      cylinder                  {
        -Grueso*z, 2*Grueso*z, RadioTornillo
        translate               Alto/2*y
        translate               -3*RadioTornillo*y
      }
      cylinder                  {
        -Grueso*z, 2*Grueso*z, RadioTornillo
        translate               -Alto/2*y
        translate               +3*RadioTornillo*y
      }
      box                       {
        <-0.95*AnchoCaja/2,-0.95*AltoCaja/2,-Grueso>,
        <+0.95*AnchoCaja/2,+0.95*AltoCaja/2,2*Grueso>
      }
    }
    // Caja Negra
    difference                  {
      box                       {
        < -AnchoCaja/2, -AltoCaja/2, Grueso >,
        < +AnchoCaja/2, +AltoCaja/2, Grueso+Fondo >
      }
      box                       {
        < -0.95*AnchoCaja/2, -0.95*AltoCaja/2, 0 >,
        < +0.95*AnchoCaja/2, +0.95*AltoCaja/2, Fondo >
      }
      texture                   {
        TexturaNegra
      }
    }    
    // Lengueta Metalica
    difference                  {
      cylinder                  {
        -1.2*AltoCaja/2*y,
        +1.2*AltoCaja/2*y,
        1.5*Fondo
      }
      cylinder                  {
        -2*AltoCaja/2*y,
        +2*AltoCaja/2*y,
        1.5*Fondo-Grueso
      }
      plane                     {
        -x, 0
      }
      plane                     {
        x, 0
        rotate 45*y
      }
      translate                 +1.5*Fondo*z
      translate                 -AnchoCaja/2*x
    }
    // Tornillo
    #if ( BanderaTornillo )
      object                    {
        LSLE_Tornillo( RadioTornillo, Grueso, LSLE_TexturaMetalica )
        translate               +Alto/2*y
        translate               -3*RadioTornillo*y
        texture                 {
          TexturaTornillo
        }
      }
      object                    {
        LSLE_Tornillo( RadioTornillo, Grueso, LSLE_TexturaMetalica )
        translate               -Alto/2*y
        translate               +3*RadioTornillo*y
        texture                 {
          TexturaTornillo
        }
      }
    #end
    texture                     {
      TexturaMetalica
    }
  }
#end  // LSLE_AccesorioParedLlaveExclusiva

#macro LSLE_Llavin( FraccionBoton )
  object                        {
    #local L                    = LSLE_L;
    #local RadioBasico          = 53/2*L;
    #local RadioPomo           = 38/2*L;
    #local ProfundidadSoporte   = 10*L;
    #local RadioColumna         = 10*L;
    #local ProfundidadColumna   = 10.5*L;
    #local RadioBoton           = 6.0/28*RadioPomo;
    LSLE_LlavinFundamental( 0, FraccionBoton,
       RadioBasico, ProfundidadSoporte,
       RadioColumna, ProfundidadColumna, RadioPomo, RadioBoton,
       LSLE_DefaultTexturaMetalica,
       LSLE_DefaultTexturaMetalicaSecundaria,
       LSLE_DefaultTexturaCerrojo )
  }
#end

#macro LSLE_AccesorioPuerta( FraccionAperturaMayor, FraccionAperturaMenor )
  object                        {
    #local L                    = LSLE_L;
    #local Alto                 = 39*L;
    #local Ancho                = 18*L;
    #local ProfundidadCilindro  = 21*L;
    #local RadioTornillo        = 4.2/2*L;
    #local RadioPrincipal       = 13.2/2*L;
    #local Grueso               = 1.0*L;
    LSLE_AccesorioPuertaLlaveExclusiva(
      FraccionAperturaMayor, FraccionAperturaMenor,
      Alto, Ancho, Grueso, RadioPrincipal,
      ProfundidadCilindro, RadioTornillo, on,
      LSLE_DefaultTexturaMetalica,
      LSLE_DefaultTexturaCerrojo,
      LSLE_DefaultTexturaTornillo
    )
  }
#end

#macro LSLE_AccesorioPared( )
  object                        {
    #local L                    = LSLE_L;
    #local Alto                 = 49*L;
    #local Ancho                = 20*L;
    #local Grueso               = 1*L;
    #local Fondo                = 7*L;
    #local RadioTornillo        = 2.1*L;
    #local RadioPrincipal       = 13.2/2*L;
    LSLE_AccesorioParedLlaveExclusiva(
      Alto, Ancho, Grueso, Fondo, RadioPrincipal, RadioTornillo, on,
      LSLE_DefaultTexturaMetalica, LSLE_DefaultTexturaNegra,
      LSLE_DefaultTexturaTornillo
    )
  }
#end


