// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 19 febrero 2014
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//        
// Este archivo dibuja una serpiente sencilla.
//
// #macro SRAV_Serpiente( MyArreglo, AvanceLengua )   
//      MyArreglo               : describe el movimiento (ver adelante)
//      AvanceLengua            : fraccion real entre 0.0 y 1.0 para
//              meter y sacar la lengua respectivamente.
//  
// #declare MyArreglo   = array [ GirosSolicitados ][ 4/5 ]
//      GirosSolicitados        : indica el total de giros a solicitar
//         El numero es libre, con un maximo de 55,
//         El giro tiene el siguiente formato
//        { IdentificadorGiro, RotarX, RotarY, RotarZ }
//         o bien este otro
//        { IdentificadorGiro, RotarX, RotarY, RotarZ, on/off }
//         la bandera off desactiva el giro, lo que podria ser util
//         al disenar.
//         Utiliza rotacion acumulada.
//         Cada tipo de giro solo debe encontarse una unica vez
//         en cualquier orden.
// IdentificadorGiro    : Numero o etiqueta clave que identifica el giro
// RotarX               : Indica la rotacion en grados respecto eje X*,
//        este es el eje X, luego de aplicar rotacion en
//        en otros puntos de control
// RotarY               : Indica rotacion acumulada respecto eje Y*,
//        este es el eje Y luego de aplicar RotarX
// RotarZ               : Indica rotacion acumulada respecto eje Z*,
//        este es el eje Z luego de aplicar RotarX y RotarY
// on/off               : variable optativa,
//        si off no se gira, util en diseno y animacion.
//
// La siguiente es la lista de IdentificadorGiro admisibles:
// SRAV_EjeCentral        = Ubicado al centro del tronco     
//      Zona delantera
// SRAV_EjeCentralD01     = Ubicado delante de SRAV_EjeCentral
// SRAV_EjeCentralD02     = Ubicado delante de SRAV_EjeCentralD01
// SRAV_EjeCentralD03     = Ubicado delante de SRAV_EjeCentralD02
// SRAV_EjeCentralD04     = Ubicado delante de SRAV_EjeCentralD03
// SRAV_EjeCentralD05     = Ubicado delante de SRAV_EjeCentralD04
// SRAV_EjeCentralD06     = Ubicado delante de SRAV_EjeCentralD05
// SRAV_EjeCentralD07     = Ubicado delante de SRAV_EjeCentralD06
// SRAV_EjeCentralD08     = Ubicado delante de SRAV_EjeCentralD07
// SRAV_EjeCentralD09     = Ubicado delante de SRAV_EjeCentralD08
// SRAV_EjeCentralD10     = Ubicado delante de SRAV_EjeCentralD09
// SRAV_EjeCentralD11     = Ubicado delante de SRAV_EjeCentralD10
// SRAV_EjeCentralD12     = Ubicado delante de SRAV_EjeCentralD11
// SRAV_EjeCentralD13     = Ubicado delante de SRAV_EjeCentralD12
// SRAV_EjeCentralD14     = Ubicado delante de SRAV_EjeCentralD13
// SRAV_EjeCentralD15     = Ubicado delante de SRAV_EjeCentralD14
// SRAV_EjeCentralD16     = Ubicado delante de SRAV_EjeCentralD15
// SRAV_EjeCentralD17     = Ubicado delante de SRAV_EjeCentralD16
// SRAV_EjeCentralD18     = Ubicado delante de SRAV_EjeCentralD17
// SRAV_EjeCentralD19     = Ubicado delante de SRAV_EjeCentralD18
// SRAV_EjeCentralD20     = Ubicado delante de SRAV_EjeCentralD19
// SRAV_EjeCentralD21     = Ubicado delante de SRAV_EjeCentralD20
// SRAV_EjeCentralD22     = Ubicado delante de SRAV_EjeCentralD21
// SRAV_EjeCentralD23     = Ubicado delante de SRAV_EjeCentralD22
// SRAV_EjeCentralD24     = Ubicado delante de SRAV_EjeCentralD23
// SRAV_EjeCentralD25     = Ubicado delante de SRAV_EjeCentralD24
// SRAV_EjeCentralD26     = Ubicado delante de SRAV_EjeCentralD25
// SRAV_EjeCentralD27     = Ubicado delante de SRAV_EjeCentralD26 
//      Zona posterior
// SRAV_EjeCentralP01     = Ubicado atras de SRAV_EjeCentral
// SRAV_EjeCentralP02     = Ubicado atras de SRAV_EjeCentralP01
// SRAV_EjeCentralP03     = Ubicado atras de SRAV_EjeCentralP02
// SRAV_EjeCentralP04     = Ubicado atras de SRAV_EjeCentralP03
// SRAV_EjeCentralP05     = Ubicado atras de SRAV_EjeCentralP04
// SRAV_EjeCentralP06     = Ubicado atras de SRAV_EjeCentralP05
// SRAV_EjeCentralP07     = Ubicado atras de SRAV_EjeCentralP06
// SRAV_EjeCentralP08     = Ubicado atras de SRAV_EjeCentralP07
// SRAV_EjeCentralP09     = Ubicado atras de SRAV_EjeCentralP08
// SRAV_EjeCentralP10     = Ubicado atras de SRAV_EjeCentralP09
// SRAV_EjeCentralP11     = Ubicado atras de SRAV_EjeCentralP10
// SRAV_EjeCentralP12     = Ubicado atras de SRAV_EjeCentralP11
// SRAV_EjeCentralP13     = Ubicado atras de SRAV_EjeCentralP12
// SRAV_EjeCentralP14     = Ubicado atras de SRAV_EjeCentralP13
// SRAV_EjeCentralP15     = Ubicado atras de SRAV_EjeCentralP14
// SRAV_EjeCentralP16     = Ubicado atras de SRAV_EjeCentralP15
// SRAV_EjeCentralP17     = Ubicado atras de SRAV_EjeCentralP16
// SRAV_EjeCentralP18     = Ubicado atras de SRAV_EjeCentralP17
// SRAV_EjeCentralP19     = Ubicado atras de SRAV_EjeCentralP18
// SRAV_EjeCentralP20     = Ubicado atras de SRAV_EjeCentralP19
// SRAV_EjeCentralP21     = Ubicado atras de SRAV_EjeCentralP20
// SRAV_EjeCentralP22     = Ubicado atras de SRAV_EjeCentralP21
// SRAV_EjeCentralP23     = Ubicado atras de SRAV_EjeCentralP22
// SRAV_EjeCentralP24     = Ubicado atras de SRAV_EjeCentralP23
// SRAV_EjeCentralP25     = Ubicado atras de SRAV_EjeCentralP24
// SRAV_EjeCentralP26     = Ubicado atras de SRAV_EjeCentralP25
// SRAV_EjeCentralP27     = Ubicado atras de SRAV_EjeCentralP26
//      
// La siguiente macro permite crear el mismo dibujo con mas control
// sobre las caracteristicas principales.
// #macro SRAV_SerpienteReptilAnimalVivo
//              ( MyArreglo, AvanceLengua, LargoPrincipal, 
//                RadioPrincipal, FactorT, LargoCabeza,
//                FactorCabeza, CorreccionZOjo, FinoCola, 
//                FactorGordo, TexturaPrincipal, TexturaCabeza,
//                TexturaCornea, TexturaEsclerotida, TexturaIris, 
//                TexturaBoca, TexturaLengua )
//      MyArreglo               : Describe el movimiento (ver arriba)
//      AvanceLengua            : Fraccion real entre 0.0 y 1.0 para
//              meter y sacar la lengua respectivamente.
//      LargoPrincipal          : Referencia para el largo de la serpiente. 
//              Default es 3000*L.
//      RadioPrincipal          : Referencia para el radio del animal.
//              Default es 60*L.
//      FactorT                 : Controla el valor threshold del blob.
//              Default es 0.9.
//      LargoCabeza             : Referencia para el largo de la cabeza. 
//              Default es 100*L.
//      FactorCabeza            : Para incrementa o reducir el grueso de la cabeza.
//              Default es 0.3.
//      CorreccionZOjo          : Corrige en Z la posicion del ojo.  Positivo hacia afuera.
//              Default es 15*L.
//      FinoCola                : Referencia como entero para el grado de finura de la cola.
//              Default es 8.
//      FactorGordo             : Referencia para engrosar al centro la serpiente.
//              Default es 0.05.
//      TexturaPrincipal        : Textura principal de la serpiente.
//              Default es SRAV_TexturaPrincipal.
//      TexturaCabeza           : Textura para aplicar a la cabeza.  Origen en cabeza.
//              Default es SRAV_TexturaCabeza.
//      TexturaCornea           : Textura para aplicar a la cornea.
//              Default es SRAV_TexturaCornea.
//      TexturaEsclerotida      : Textura para aplicar a la esclerotida.
//              Default es SRAV_TexturaEsclerotida.
//      TexturaIris             : Textura para aplicar al iris.
//              Default es SRAV_TexturaIris.                       
//      TexturaBoca             : Textura para aplicar a la boca.  Se aplica por diferencia,
//              poco perceptible.  Default es SRAV_TexturaBoca.
//      TexturaLengua           : Textura para aplicar a la lengua.  
//              Default es SRAV_TexturaLengua.
//  
// Crea el dibujo de una serpiente en estilo 3D
// con el centro del tronco en el origen y la
// cabeza orientada hacia X+.  Las siguientes son caracteristicas
// al suprimir todos los giros.
// LargoTotal en X              : -1400..+1620
// AltoTotal en Y               : -  45..+  60
// ProfundidadTotal en Z        : -  65..+  65    
//
// PREDEFINIDOS
// Las siguientes variables no deberian modificarse 
// SRAV_DefaultTexturaPrincipal        
//              Textura principal de la serpiente.
// SRAV_DefaultTexturaCabeza           
//              Textura para aplicar a la cabeza.  Origen en cabeza.
// SRAV_DefaultTexturaCornea           
//              Textura para aplicar a la cornea.
// SRAV_DefaultTexturaEsclerotida      
//              Textura para aplicar a la esclerotida.
// SRAV_DefaultTexturaIris             
//              Textura para aplicar al iris.
// SRAV_DefaultTexturaBoca             
//              Textura para aplicar a la boca. 
// SRAV_DefaultTexturaLengua           
//              Textura para aplicar a la lengua.  
//
// MODIFICADORES
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare LRAV_POV3_1         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare SRAV_TexturaPrincipal               = texture { ... }      
//      Textura principal de la serpiente.
// #declare SRAV_TexturaCabeza                  = texture { ... }     
//      Textura para aplicar a la cabeza.  Origen en cabeza.
// #declare SRAV_TexturaCornea                  = texture { ... }         
//      Textura para aplicar a la cornea.
// #declare SRAV_TexturaEsclerotida             = texture { ... }     
//      Textura para aplicar a la esclerotida.
// #declare SRAV_TexturaIris                    = texture { ... }         
//      Textura para aplicar al iris.
// #declare SRAV_TexturaBoca                    = texture { ... }           
//      Textura para aplicar a la boca.  Dificil de percibir, se aplica por diferencia. 
// #declare SRAV_TexturaLengua                  = texture { ... }        
//      Textura para aplicar a la lengua.  
//
// Para colocarlo sin giros
// #include "SRAV.inc"
// #declare MyArreglo   = [1][5] = {{SRAV_EjeCentral,0,0,0,off}}
// object { SRAV_Serpiente( MyArreglo, 0 ) }
//    
// Con la macro detallada.
// #include "SRAV.inc"
// #declare MyArreglo   = [1][5] = {{SRAV_EjeCentral,0,0,0,off}}
// object { SRAV_SerpienteReptilAnimalVivo( MyArreglo, 0,  
//              3.0, 0.06, 0.9, 0.1, 0.3, 0.015, 8, 0.05,        
//              SRAV_TexturaPrincipal, SRAV_TexturaCabeza,
//              SRAV_TexturaCornea, SRAV_TexturaEsclerotida, SRAV_TexturaIris, 
//              SRAV_TexturaBoca, SRAV_TexturaLengua ) }
//
// Otro ejemplo
// #include "SRAV.inc"
// #declare SRAV_TexturaCabeza             = texture       { pigment { Green } }
// #declare MyArreglo   = array [ 2 ][ 4 ]
//      { { SRAV_EjeCentral     , 0, 10, 0 },
//        { SRAV_EjeCentralD01  , 0,-10, 0 } }
// object       { SRAV_Serpiente( MyArreglo, 1.0 ) }
// 

#include "colors.inc"    
#include "textures.inc"

#declare SRAV_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( SRAV_POV3_1 )
    #declare SRAV_POV3_1        = on;
  #end
#else
  #ifndef( SRAV_POV3_1 )
    #declare SRAV_POV3_1        = off;
  #end
#end

#declare SRAV_DefaultTexturaCabeza   =
  texture                       {                                     
    checker   
    texture {   
      pigment                   {
        #if ( SRAV_POV3_1 )
          bumps
        #else
          Hex_Tiles_Ptrn()
        #end
        turbulence      0.3      
        scale             0.005  
        rotate            0*x
        pigment_map               {   
          [ 0 Pine_Wood ]
          [ 0.20 Pine_Wood] 
          [ 0.20 Brown_Agate ]
          [ 1 Brown_Agate ]
        }
      }  
    }
    texture             { 
      pigment                   {
        #if ( SRAV_POV3_1 )
          bumps
        #else
          Hex_Tiles_Ptrn()
        #end
        turbulence      0.3      
        scale             0.0025  
        rotate            90*x
        pigment_map               {   
          [ 0 White_Marble scale 10 ]
          [ 0.20 White_Marble scale 10 ] 
          [ 0.20 White_Wood ]
          [ 1 White_Wood ]
        }
      }  
    } 
    turbulence          0.01 
    translate           -0.5*z-0.5*x   
    scale               <4,1,1>        
  }
  
#ifndef ( SRAV_TexturaCabeza )    
  #declare SRAV_TexturaCabeza        = SRAV_DefaultTexturaCabeza
#end 
    
#declare SRAV_DefaultTexturaIris     =
  texture                       {                                     
    pigment { Black }
  }
  
#ifndef ( SRAV_TexturaIris )    
  #declare SRAV_TexturaIris          = SRAV_DefaultTexturaIris
#end 

#declare SRAV_DefaultTexturaBoca     =
  texture                       {                                     
    Blood_Sky
  }
  
#ifndef ( SRAV_TexturaBoca )    
  #declare SRAV_TexturaBoca          = SRAV_DefaultTexturaBoca
#end 

#declare SRAV_DefaultTexturaEsclerotida          =
  texture                       {                                     
    White_Marble
    scale       0.001
  }
  
#ifndef ( SRAV_TexturaEsclerotida )    
  #declare SRAV_TexturaEsclerotida   = SRAV_DefaultTexturaEsclerotida
#end 

#declare SRAV_DefaultTexturaCornea   =
  texture                       {                                     
    pigment { White transmit 0.7 } 
    normal      { bumps scale 0.01 }
  }
  
#ifndef ( SRAV_TexturaCornea )    
  #declare SRAV_TexturaCornea        = SRAV_DefaultTexturaCornea
#end 
 
#declare SRAV_DefaultTexturaLengua   =
  texture                       {                                     
    pigment { Red } 
    normal      { bumps scale 0.01 }
    finish      { phong 0.5 }
  }
  
#ifndef ( SRAV_TexturaLengua )    
  #declare SRAV_TexturaLengua        = SRAV_DefaultTexturaLengua
#end 
          
#declare SRAV_DefaultTexturaPrincipal   =
  texture                       {                                     
    checker   
    texture {   
      pigment                   {
        #if ( SRAV_POV3_1 )
          bumps
        #else
          Hex_Tiles_Ptrn()
        #end
        turbulence      0.3      
        scale             0.005  
        rotate            0*x
        pigment_map               {   
          [ 0 Pine_Wood ]
          [ 0.20 Pine_Wood] 
          [ 0.20 Brown_Agate ]
          [ 1 Brown_Agate ]
        }
      }  
    }
    texture             { 
      pigment                   {
        #if ( SRAV_POV3_1 )
          bumps
        #else
          Hex_Tiles_Ptrn()
        #end
        turbulence      0.3      
        scale             0.0025  
        rotate            90*x
        pigment_map               {   
          [ 0 White_Marble scale 10 ]
          [ 0.20 White_Marble scale 10 ] 
          [ 0.20 White_Wood ]
          [ 1 White_Wood ]
        }
      }  
    } 
    turbulence          0.01 
    translate           -0.5*z-0.5*x   
    scale               <4,1,1>        
   }
  
#ifndef ( SRAV_TexturaPrincipal )    
  #declare SRAV_TexturaPrincipal        = SRAV_DefaultTexturaPrincipal
#end  

#declare SRAV_IndiceTotal       = 8;
#declare SRAV_MovimientoTotal   = 56;
#declare SRAV_MovimientoCilindricoDelantero     = 27;
#declare SRAV_MovimientoCilindricoPosterior     = 27;

#declare SRAV_IndiceActual      = 0;                       
#declare SRAV_IndicePadre       = 1;                       
#declare SRAV_IndiceX           = 2;
#declare SRAV_IndiceY           = 3;
#declare SRAV_IndiceZ           = 4;
#declare SRAV_IndiceRotX        = 5;
#declare SRAV_IndiceRotY        = 6;
#declare SRAV_IndiceRotZ        = 7;


#declare SRAV_EjeBase           = 0; 
#declare SRAV_EjeCentral        = 1; 
#declare SRAV_EjeCentralD01     = 2;
#declare SRAV_EjeCentralD02     = SRAV_EjeCentralD01+1;
#declare SRAV_EjeCentralD03     = SRAV_EjeCentralD01+2;
#declare SRAV_EjeCentralD04     = SRAV_EjeCentralD01+3;
#declare SRAV_EjeCentralD05     = SRAV_EjeCentralD01+4;
#declare SRAV_EjeCentralD06     = SRAV_EjeCentralD01+5;
#declare SRAV_EjeCentralD07     = SRAV_EjeCentralD01+6;
#declare SRAV_EjeCentralD08     = SRAV_EjeCentralD01+7;
#declare SRAV_EjeCentralD09     = SRAV_EjeCentralD01+8;
#declare SRAV_EjeCentralD10     = SRAV_EjeCentralD01+9;
#declare SRAV_EjeCentralD11     = SRAV_EjeCentralD01+10;
#declare SRAV_EjeCentralD12     = SRAV_EjeCentralD01+11;
#declare SRAV_EjeCentralD13     = SRAV_EjeCentralD01+12;
#declare SRAV_EjeCentralD14     = SRAV_EjeCentralD01+13;
#declare SRAV_EjeCentralD15     = SRAV_EjeCentralD01+14;
#declare SRAV_EjeCentralD16     = SRAV_EjeCentralD01+15;
#declare SRAV_EjeCentralD17     = SRAV_EjeCentralD01+16;
#declare SRAV_EjeCentralD18     = SRAV_EjeCentralD01+17;
#declare SRAV_EjeCentralD19     = SRAV_EjeCentralD01+18;
#declare SRAV_EjeCentralD20     = SRAV_EjeCentralD01+19;
#declare SRAV_EjeCentralD21     = SRAV_EjeCentralD01+20;
#declare SRAV_EjeCentralD22     = SRAV_EjeCentralD01+21;
#declare SRAV_EjeCentralD23     = SRAV_EjeCentralD01+22;
#declare SRAV_EjeCentralD24     = SRAV_EjeCentralD01+23;
#declare SRAV_EjeCentralD25     = SRAV_EjeCentralD01+24;
#declare SRAV_EjeCentralD26     = SRAV_EjeCentralD01+25;
#declare SRAV_EjeCentralD27     = SRAV_EjeCentralD01+26;

#declare SRAV_EjeCentralP01     = 29;
#declare SRAV_EjeCentralP02     = SRAV_EjeCentralP01+1;
#declare SRAV_EjeCentralP03     = SRAV_EjeCentralP01+2;
#declare SRAV_EjeCentralP04     = SRAV_EjeCentralP01+3;
#declare SRAV_EjeCentralP05     = SRAV_EjeCentralP01+4;
#declare SRAV_EjeCentralP06     = SRAV_EjeCentralP01+5;
#declare SRAV_EjeCentralP07     = SRAV_EjeCentralP01+6;
#declare SRAV_EjeCentralP08     = SRAV_EjeCentralP01+7;
#declare SRAV_EjeCentralP09     = SRAV_EjeCentralP01+8;
#declare SRAV_EjeCentralP10     = SRAV_EjeCentralP01+9;
#declare SRAV_EjeCentralP11     = SRAV_EjeCentralP01+10;
#declare SRAV_EjeCentralP12     = SRAV_EjeCentralP01+11;
#declare SRAV_EjeCentralP13     = SRAV_EjeCentralP01+12;
#declare SRAV_EjeCentralP14     = SRAV_EjeCentralP01+13;
#declare SRAV_EjeCentralP15     = SRAV_EjeCentralP01+14;
#declare SRAV_EjeCentralP16     = SRAV_EjeCentralP01+15;
#declare SRAV_EjeCentralP17     = SRAV_EjeCentralP01+16;
#declare SRAV_EjeCentralP18     = SRAV_EjeCentralP01+17;
#declare SRAV_EjeCentralP19     = SRAV_EjeCentralP01+18;
#declare SRAV_EjeCentralP20     = SRAV_EjeCentralP01+19;
#declare SRAV_EjeCentralP21     = SRAV_EjeCentralP01+20;
#declare SRAV_EjeCentralP22     = SRAV_EjeCentralP01+21;
#declare SRAV_EjeCentralP23     = SRAV_EjeCentralP01+22;
#declare SRAV_EjeCentralP24     = SRAV_EjeCentralP01+23;
#declare SRAV_EjeCentralP25     = SRAV_EjeCentralP01+24;
#declare SRAV_EjeCentralP26     = SRAV_EjeCentralP01+25;
#declare SRAV_EjeCentralP27     = SRAV_EjeCentralP01+26;


//   
           
#declare SRAV_Movimiento        = 
        array [ SRAV_MovimientoTotal ][ SRAV_IndiceTotal ]     
  {
    { SRAV_EjeBase            , SRAV_EjeBase                  ,
                0             , 0             , 0             ,       
                0             , 0             , 0             },
    { SRAV_EjeCentral         , SRAV_EjeBase                  ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD01      , SRAV_EjeCentral               ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD02      , SRAV_EjeCentralD01            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD03      , SRAV_EjeCentralD02            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD04      , SRAV_EjeCentralD03            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD05      , SRAV_EjeCentralD04            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD06      , SRAV_EjeCentralD05            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD07      , SRAV_EjeCentralD06            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD08      , SRAV_EjeCentralD07            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD09      , SRAV_EjeCentralD08            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD10      , SRAV_EjeCentralD09            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD11      , SRAV_EjeCentralD10            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD12      , SRAV_EjeCentralD11            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD13      , SRAV_EjeCentralD12            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD14      , SRAV_EjeCentralD13            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD15      , SRAV_EjeCentralD14            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD16      , SRAV_EjeCentralD15            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD17      , SRAV_EjeCentralD16            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD18      , SRAV_EjeCentralD17            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD19      , SRAV_EjeCentralD18            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD20      , SRAV_EjeCentralD19            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD21      , SRAV_EjeCentralD20            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD22      , SRAV_EjeCentralD21            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD23      , SRAV_EjeCentralD22            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD24      , SRAV_EjeCentralD23            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD25      , SRAV_EjeCentralD24            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD26      , SRAV_EjeCentralD25            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralD27      , SRAV_EjeCentralD26            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP01      , SRAV_EjeCentral               ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP02      , SRAV_EjeCentralP01            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP03      , SRAV_EjeCentralP02            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP04      , SRAV_EjeCentralP03            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP05      , SRAV_EjeCentralP04            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP06      , SRAV_EjeCentralP05            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP07      , SRAV_EjeCentralP06            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP08      , SRAV_EjeCentralP07            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP09      , SRAV_EjeCentralP08            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP10      , SRAV_EjeCentralP09            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP11      , SRAV_EjeCentralP10            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP12      , SRAV_EjeCentralP11            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP13      , SRAV_EjeCentralP12            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP14      , SRAV_EjeCentralP13            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP15      , SRAV_EjeCentralP14            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP16      , SRAV_EjeCentralP15            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP17      , SRAV_EjeCentralP16            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP18      , SRAV_EjeCentralP17            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP19      , SRAV_EjeCentralP18            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP20      , SRAV_EjeCentralP19            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP21      , SRAV_EjeCentralP20            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP22      , SRAV_EjeCentralP21            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP23      , SRAV_EjeCentralP22            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP24      , SRAV_EjeCentralP23            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP25      , SRAV_EjeCentralP24            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP26      , SRAV_EjeCentralP25            ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { SRAV_EjeCentralP27      , SRAV_EjeCentralP26            ,
                0             , 0             , 0             ,
                0             , 0             , 0             }
 }    
 
#macro SRAV_KeyMovimiento ( Identificador )
  #local A              = 0;
  #while ( !( SRAV_Movimiento[ A ][ SRAV_IndiceActual ] = 
                        Identificador ) )
    #local A            = A+1;
    // Es un ciclo infinito si error...
    // Se utilizo 0 en vez de SRAV_IndiceActual por velocidad.
  #end
  #local Identificador  = A;
#end
  
#macro SRAV_MoverBlob ( Eje, MiPunto )
  #local NuevoEje               = Eje; 
  SRAV_KeyMovimiento( NuevoEje )
  #while ( !( NuevoEje = SRAV_EjeBase ) )
    #local Pivote               = MiPunto-
                < SRAV_Movimiento[ NuevoEje ][ SRAV_IndiceX ],
                  SRAV_Movimiento[ NuevoEje ][ SRAV_IndiceY ],
                  SRAV_Movimiento[ NuevoEje ][ SRAV_IndiceZ ] >;
    #local Pivote               = vaxis_rotate
        ( Pivote, x, SRAV_Movimiento[ NuevoEje ][ SRAV_IndiceRotX ] );
    #local PivoteEje            = vaxis_rotate
 ( y, x, SRAV_Movimiento[ NuevoEje ][ SRAV_IndiceRotX ] );        
    #local PivoteEje2           = vaxis_rotate
 ( z, x, SRAV_Movimiento[ NuevoEje ][ SRAV_IndiceRotX ] );        
    #local Pivote               = vaxis_rotate
 ( Pivote, PivoteEje, SRAV_Movimiento[ NuevoEje ][ SRAV_IndiceRotY ] );
    #local PivoteEje2           = vaxis_rotate
        ( PivoteEje2, PivoteEje, 
                SRAV_Movimiento[ NuevoEje ][ SRAV_IndiceRotY ] );        
    #local Pivote           = vaxis_rotate
 ( Pivote, PivoteEje2, SRAV_Movimiento[ NuevoEje ][ SRAV_IndiceRotZ ] );
    #local MiPunto              = Pivote+
                < SRAV_Movimiento[ NuevoEje ][ SRAV_IndiceX ],
                  SRAV_Movimiento[ NuevoEje ][ SRAV_IndiceY ],
                  SRAV_Movimiento[ NuevoEje ][ SRAV_IndiceZ ] >;
    #local NuevoEje             = 
                SRAV_Movimiento[ NuevoEje ][ SRAV_IndicePadre ];
    SRAV_KeyMovimiento( NuevoEje )
  #end
#end

#macro SRAV_AnularArreglo()       
  #local C                      = 0;
  #while ( C < SRAV_MovimientoTotal ) 
    #declare SRAV_Movimiento[C][SRAV_IndiceRotX]        = 0;    
    #declare SRAV_Movimiento[C][SRAV_IndiceRotY]        = 0;    
    #declare SRAV_Movimiento[C][SRAV_IndiceRotZ]        = 0;    
    #local C                    = C+1;
  #end  // #while ( C < SRAV_MovimientoTotal )
#end  // #macro SRAV_AnularArreglo                    
                      


#macro SRAV_SerpienteReptilAnimalVivo
  ( MyArreglo, AvanceLengua, LargoPrincipal, RadioPrincipal, FactorT, LargoCabeza,
    FactorCabeza, CorreccionZOjo, FinoCola, FactorGordo, TexturaPrincipal, TexturaCabeza,
    TexturaCornea, TexturaEsclerotida, TexturaIris, TexturaBoca, TexturaLengua )
  union                         {    
  SRAV_AnularArreglo()
  #local C      = 0;      
  #local TotalMyArreglo         = dimension_size( MyArreglo, 1 );
  #local BanderaActivo          = 
                ( dimension_size( MyArreglo, 2 ) <= 4 );
  #local BanderaExtra           = true;
  #while ( C < TotalMyArreglo )
    #if ( !( BanderaActivo ) )
      #local BanderaExtra       = MyArreglo[ C ][ 4 ];
    #end
    #if ( ( BanderaActivo ) | ( BanderaExtra ) )
      #local Eje  = MyArreglo[ C ][ 0 ];
      SRAV_KeyMovimiento( Eje )
      #declare SRAV_Movimiento[ Eje ][ SRAV_IndiceRotX ]  =
                                                MyArreglo[ C ][ 1 ];
      #declare SRAV_Movimiento[ Eje ][ SRAV_IndiceRotY ]  =
                                                MyArreglo[ C ][ 2 ];
      #declare SRAV_Movimiento[ Eje ][ SRAV_IndiceRotZ ]  =
                                                MyArreglo[ C ][ 3 ];
    #end
  #local C      = C+1;
  #end
    #local DeltaCilindro        =
      ( LargoPrincipal/2 )/SRAV_MovimientoCilindricoDelantero;
    #local PivC                 = SRAV_EjeCentralD01+SRAV_MovimientoCilindricoDelantero-1;
    #local C                    = SRAV_EjeCentralD01;    
    #local PuntoCabeza          = ( LargoPrincipal/2+LargoCabeza/2 )*x;
    #while ( C < ( SRAV_EjeCentralD01+SRAV_MovimientoCilindricoDelantero ) )
      #declare SRAV_Movimiento[C][SRAV_IndiceX]  =
                ( C-SRAV_EjeCentralD01+0.5 )*DeltaCilindro;
      #local C                  = C+1;
    #end
    #local DeltaCilindro        =
      ( LargoPrincipal/2 )/( SRAV_MovimientoCilindricoDelantero+1 );
    #local C                    = SRAV_EjeCentralP01;
    #while ( C < ( SRAV_EjeCentralP01+SRAV_MovimientoCilindricoPosterior ) )
      #declare SRAV_Movimiento[C][SRAV_IndiceX]  =
                -( C-SRAV_EjeCentralP01+0.5 )*DeltaCilindro;
      #if ( C > ( SRAV_EjeCentralP01+SRAV_MovimientoCilindricoPosterior-FinoCola ) )
        #declare SRAV_Movimiento[C][SRAV_IndiceY]       =
             -RadioPrincipal/3*
             ( C-( SRAV_EjeCentralP01+SRAV_MovimientoCilindricoPosterior-FinoCola ) )/
             FinoCola;
      #end
      #local C                  = C+1;
    #end
    difference                  {
      blob                        {
        threshold                 FactorT
        #local C                    = SRAV_EjeCentralD01;
        #while ( C <
              ( SRAV_EjeCentralD01+SRAV_MovimientoCilindricoDelantero ) )
              
          #local PuntoPivote    = <SRAV_Movimiento[C][SRAV_IndiceX],
                                   SRAV_Movimiento[C][SRAV_IndiceY],
                                   SRAV_Movimiento[C][SRAV_IndiceZ]>; 
          #local PuntoOriginal  = PuntoPivote;                         
          #local PuntoEjeX      = PuntoPivote+x; 
          #local PuntoEjeY      = PuntoPivote+y;
          #local PuntoEjeZ      = PuntoPivote+z;                        
          SRAV_MoverBlob(C,PuntoPivote)         
          SRAV_MoverBlob(C,PuntoEjeX)
          SRAV_MoverBlob(C,PuntoEjeY)
          SRAV_MoverBlob(C,PuntoEjeZ)
          #local PuntoEjeX      = PuntoEjeX-PuntoPivote;
          #local PuntoEjeY      = PuntoEjeY-PuntoPivote;
          #local PuntoEjeZ      = PuntoEjeZ-PuntoPivote;
          #if ( C = SRAV_EjeCentralD01 )
            #local PuntoPivote2   = <SRAV_Movimiento[SRAV_EjeCentralP01][SRAV_IndiceX],
                                     SRAV_Movimiento[SRAV_EjeCentralP01][SRAV_IndiceY],
                                     SRAV_Movimiento[SRAV_EjeCentralP01][SRAV_IndiceZ]>;
          #else
            #local PuntoPivote2   = <SRAV_Movimiento[C-1][SRAV_IndiceX],
                                     SRAV_Movimiento[C-1][SRAV_IndiceY],
                                     SRAV_Movimiento[C-1][SRAV_IndiceZ]>;
          #end
          SRAV_MoverBlob(C,PuntoPivote2)
          #local RadioCilindro  = RadioPrincipal*( 0.95+( 0.05+FactorGordo )*
               ( SRAV_EjeCentralD01+SRAV_MovimientoCilindricoDelantero-C )/
               ( SRAV_MovimientoCilindricoDelantero ) );
          cylinder              {
            ( 1.0*PuntoPivote+1.0*PuntoPivote2 )/2,
            ( 3.0*PuntoPivote-1.0*PuntoPivote2 )/2, RadioCilindro, 1
            texture             { 
              TexturaPrincipal   
              translate         -RadioPrincipal*0.2*y   
              translate         -PuntoOriginal
              matrix                <PuntoEjeX.x,PuntoEjeX.y,PuntoEjeX.z,
                 PuntoEjeY.x,PuntoEjeY.y,PuntoEjeY.z,
                 PuntoEjeZ.x,PuntoEjeZ.y,PuntoEjeZ.z,
                 PuntoPivote.x,PuntoPivote.y,PuntoPivote.z>
            }
          }
          #local C                  = C+1;
        #end
        
        #local C                    = SRAV_EjeCentralP01;
        #local Fino                 = FinoCola;
        #while ( C <
              ( SRAV_EjeCentralP01+SRAV_MovimientoCilindricoPosterior ) )
          #local PuntoPivote    = <SRAV_Movimiento[C][SRAV_IndiceX],
                                   SRAV_Movimiento[C][SRAV_IndiceY],
                                   SRAV_Movimiento[C][SRAV_IndiceZ]>;
          #local PuntoOriginal  = PuntoPivote;                         
          #local PuntoEjeX      = PuntoPivote+x; 
          #local PuntoEjeY      = PuntoPivote+y;
          #local PuntoEjeZ      = PuntoPivote+z;                        
          SRAV_MoverBlob(C,PuntoPivote)         
          SRAV_MoverBlob(C,PuntoEjeX)
          SRAV_MoverBlob(C,PuntoEjeY)
          SRAV_MoverBlob(C,PuntoEjeZ)
          #local PuntoEjeX      = PuntoEjeX-PuntoPivote;
          #local PuntoEjeY      = PuntoEjeY-PuntoPivote;
          #local PuntoEjeZ      = PuntoEjeZ-PuntoPivote;
          #if ( C = SRAV_EjeCentralP01 )
            #local PuntoPivote2   = <SRAV_Movimiento[SRAV_EjeCentralD01][SRAV_IndiceX],
                                     SRAV_Movimiento[SRAV_EjeCentralD01][SRAV_IndiceY],
                                     SRAV_Movimiento[SRAV_EjeCentralD01][SRAV_IndiceZ]>;
          #else
            #local PuntoPivote2   = <SRAV_Movimiento[C-1][SRAV_IndiceX],
                                     SRAV_Movimiento[C-1][SRAV_IndiceY],
                                     SRAV_Movimiento[C-1][SRAV_IndiceZ]>;
          #end
          SRAV_MoverBlob(C,PuntoPivote2)
          #if ( C <= (SRAV_EjeCentralP01+SRAV_MovimientoCilindricoPosterior-Fino) )
            #local RadioCilindro  = RadioPrincipal*( 0.90+( 0.10+FactorGordo )*
                 ( SRAV_EjeCentralP01+SRAV_MovimientoCilindricoPosterior-Fino-C )/
                 ( SRAV_MovimientoCilindricoPosterior-Fino ) );
            #local EstiraCola     = 0.0;     
          #else
            #local RadioCilindro  = RadioPrincipal*0.90*
              ( SRAV_EjeCentralP01+SRAV_MovimientoCilindricoPosterior-C )/Fino;   
            #local EstiraCola     = 0.6;  
          #end 
          #local PuntoPivote3     = vnormalize( PuntoPivote2-PuntoPivote ); 
          #local PuntoPivote4     = vcross( PuntoPivote3, z );  
          #if ( vlength( PuntoPivote4 ) != 0 )   
            #local PuntoPivote4   = vnormalize( PuntoPivote4 );
          #else                                              
            #local PuntoPivote4   = y;
          #end   
          cylinder              {
            ( (1.0-EstiraCola)*PuntoPivote+(1.0+EstiraCola)*PuntoPivote2 )/2,
            ( (3.0+EstiraCola)*PuntoPivote-(1.0+EstiraCola)*PuntoPivote2 )/2, RadioCilindro, 1
            texture { 
              TexturaPrincipal 
              translate         -RadioPrincipal*0.2*y   
              translate         -PuntoOriginal
              matrix                <PuntoEjeX.x,PuntoEjeX.y,PuntoEjeX.z,
                 PuntoEjeY.x,PuntoEjeY.y,PuntoEjeY.z,
                 PuntoEjeZ.x,PuntoEjeZ.y,PuntoEjeZ.z,
                 PuntoPivote.x,PuntoPivote.y,PuntoPivote.z>
               
            }
          }
          #local C                  = C+1;
        #end               
        #local PuntoPivote        = <LargoPrincipal/2+LargoCabeza,0,0>;
        #local PuntoOriginal  = PuntoPivote;                         
        #local PuntoEjeX      = PuntoPivote+x; 
        #local PuntoEjeY      = PuntoPivote+y;
        #local PuntoEjeZ      = PuntoPivote+z;                        
        SRAV_MoverBlob(PivC,PuntoPivote)         
        SRAV_MoverBlob(PivC,PuntoEjeX)
        SRAV_MoverBlob(PivC,PuntoEjeY)
        SRAV_MoverBlob(PivC,PuntoEjeZ)
        #local PuntoEjeX      = PuntoEjeX-PuntoPivote;
        #local PuntoEjeY      = PuntoEjeY-PuntoPivote;
        #local PuntoEjeZ      = PuntoEjeZ-PuntoPivote;
        sphere                    {
          PuntoPivote, RadioPrincipal, 1
          texture       { 
            TexturaCabeza 
            translate         -PuntoOriginal+PuntoCabeza
            matrix                <PuntoEjeX.x,PuntoEjeX.y,PuntoEjeX.z,
                 PuntoEjeY.x,PuntoEjeY.y,PuntoEjeY.z,
                 PuntoEjeZ.x,PuntoEjeZ.y,PuntoEjeZ.z,
                 PuntoPivote.x,PuntoPivote.y,PuntoPivote.z>
          }
        }
        #local TotalCabeza        = ceil( LargoCabeza/RadioPrincipal );
        #local C                  = 0;
        #while ( C < TotalCabeza )
          #local PuntoPivote      =
            < LargoPrincipal/2+C/TotalCabeza*LargoCabeza,
            RadioPrincipal/4*( TotalCabeza-C )/TotalCabeza,
            FactorCabeza*RadioPrincipal*( TotalCabeza-C )/TotalCabeza >;
          #local PuntoPivote2     = PuntoPivote*<1,1,-1>; 
          #local PuntoOriginal  = PuntoPivote;                         
          #local PuntoEjeX      = PuntoPivote+x; 
          #local PuntoEjeY      = PuntoPivote+y;
          #local PuntoEjeZ      = PuntoPivote+z;                        
          SRAV_MoverBlob(PivC,PuntoPivote)         
          SRAV_MoverBlob(PivC,PuntoEjeX)
          SRAV_MoverBlob(PivC,PuntoEjeY)
          SRAV_MoverBlob(PivC,PuntoEjeZ)   
          // Es algo ineficiente pues todos los puntos de la cabeza tienen los mismos ejes
          // en mejores versiones se espera que no sea asi
          #local PuntoEjeX      = PuntoEjeX-PuntoPivote;
          #local PuntoEjeY      = PuntoEjeY-PuntoPivote;
          #local PuntoEjeZ      = PuntoEjeZ-PuntoPivote;
          SRAV_MoverBlob( SRAV_EjeCentralD01+SRAV_MovimientoCilindricoDelantero-1,
              PuntoPivote2 )
          cylinder                {
            PuntoPivote, PuntoPivote2, RadioPrincipal*(1+0.2*4*(TotalCabeza-C)/TotalCabeza ), 1
            texture { TexturaCabeza 
            translate         -PuntoOriginal+PuntoCabeza
            matrix                <PuntoEjeX.x,PuntoEjeX.y,PuntoEjeX.z,
                 PuntoEjeY.x,PuntoEjeY.y,PuntoEjeY.z,
                 PuntoEjeZ.x,PuntoEjeZ.y,PuntoEjeZ.z,
                 PuntoPivote.x,PuntoPivote.y,PuntoPivote.z>
            }
          }
          #local C                = C+1;
        #end
        
      }
      #local C                    = 0;
      #while ( C < 2 )
        union                     {
          #local PuntoPivote      = < LargoPrincipal/2+2*LargoCabeza/3,
                  0.5*RadioPrincipal/2, 1.425*RadioPrincipal*FactorCabeza+CorreccionZOjo >;
          #if ( C = 0 )
            #local PuntoPivote    = PuntoPivote*<1,1,-1>;
          #end
          #local PuntoPivote2     = PuntoPivote*<1,1,0>;
          #local PuntoPivote3     = PuntoPivote*<1.1,1,1>;
          #local PuntoPivote4     = PuntoPivote*<1,1.1,1>;
          SRAV_MoverBlob( SRAV_EjeCentralD01+SRAV_MovimientoCilindricoDelantero-1,
              PuntoPivote )
          SRAV_MoverBlob( SRAV_EjeCentralD01+SRAV_MovimientoCilindricoDelantero-1,
              PuntoPivote2 )
          SRAV_MoverBlob( SRAV_EjeCentralD01+SRAV_MovimientoCilindricoDelantero-1,
              PuntoPivote3 )
          SRAV_MoverBlob( SRAV_EjeCentralD01+SRAV_MovimientoCilindricoDelantero-1,
              PuntoPivote4 )
          #local PuntoPivote2     = vnormalize( PuntoPivote-PuntoPivote2 );
          #local PuntoPivote3     = vnormalize( PuntoPivote3-PuntoPivote );
          #local PuntoPivote4     = vnormalize( PuntoPivote4-PuntoPivote );
          sphere                  {
            0, RadioPrincipal/4
            scale         <1,1,1/2>
            rotate        -20*x
            rotate        30*y
            matrix                <PuntoPivote3.x,PuntoPivote3.y,PuntoPivote3.z,
               PuntoPivote4.x,PuntoPivote4.y,PuntoPivote4.z,
               PuntoPivote2.x,PuntoPivote2.y,PuntoPivote2.z,
               PuntoPivote.x,PuntoPivote.y,PuntoPivote.z>
            texture  { TexturaEsclerotida }
          }
        }
        #local C                  = C+1;
      #end 
      difference                  {
        box                         {
          -1,1
          rotate            45*z
          rotate            45*x
          
        }
        box                         {
          -1,1
          rotate            45*z
          rotate            45*x
          translate         0.3*y
        }
        scale             0.05*y
        scale
          <LargoCabeza/3,RadioPrincipal,RadioPrincipal*3*FactorCabeza>
        #local PuntoPivote      = < LargoPrincipal/2+4*LargoCabeza/5,
            -RadioPrincipal/4, 0 >;
        SRAV_MoverBlob( SRAV_EjeCentralD01+SRAV_MovimientoCilindricoDelantero-1,
            PuntoPivote )
        matrix                <PuntoPivote3.x,PuntoPivote3.y,PuntoPivote3.z,
               PuntoPivote4.x,PuntoPivote4.y,PuntoPivote4.z,
               PuntoPivote2.x,PuntoPivote2.y,PuntoPivote2.z,
               PuntoPivote.x,PuntoPivote.y,PuntoPivote.z>
        texture           { TexturaBoca }
      }
    }  
      prism                     {    
        0, RadioPrincipal*0.01 
        6,
        <0,RadioPrincipal*0.05>,
        <RadioPrincipal*2,RadioPrincipal*0.2>,
        <RadioPrincipal*1.5,0>,
        <RadioPrincipal*2,-RadioPrincipal*0.2>,
        <0,-RadioPrincipal*0.05>,
        <0,RadioPrincipal*0.05> 
        #local PuntoPivote      = < LargoPrincipal/2+( 1.5*AvanceLengua-0.5 )*LargoCabeza/5,
            -0.3*RadioPrincipal, 0 >;
        SRAV_MoverBlob( SRAV_EjeCentralD01+SRAV_MovimientoCilindricoDelantero-1,
            PuntoPivote )
        matrix                <PuntoPivote3.x,PuntoPivote3.y,PuntoPivote3.z,
               PuntoPivote4.x,PuntoPivote4.y,PuntoPivote4.z,
               PuntoPivote2.x,PuntoPivote2.y,PuntoPivote2.z,
               PuntoPivote.x,PuntoPivote.y,PuntoPivote.z>    
        texture { TexturaLengua }
      }
    
    #local C                    = 0;
    #while ( C < 2 )
      union                     {
        #local PuntoPivote      = < LargoPrincipal/2+2*LargoCabeza/3,
                0.5*RadioPrincipal/2, 1.425*RadioPrincipal*FactorCabeza+CorreccionZOjo >;
        #if ( C = 0 )
          #local PuntoPivote    = PuntoPivote*<1,1,-1>;
        #end
        #local PuntoPivote2     = PuntoPivote*<1,1,0>;
        #local PuntoPivote3     = PuntoPivote*<1.1,1,1>;
        #local PuntoPivote4     = PuntoPivote*<1,1.1,1>;
        SRAV_MoverBlob( SRAV_EjeCentralD01+SRAV_MovimientoCilindricoDelantero-1,
            PuntoPivote )
        SRAV_MoverBlob( SRAV_EjeCentralD01+SRAV_MovimientoCilindricoDelantero-1,
            PuntoPivote2 )
        SRAV_MoverBlob( SRAV_EjeCentralD01+SRAV_MovimientoCilindricoDelantero-1,
            PuntoPivote3 )
        SRAV_MoverBlob( SRAV_EjeCentralD01+SRAV_MovimientoCilindricoDelantero-1,
            PuntoPivote4 )
        #local PuntoPivote2     = vnormalize( PuntoPivote-PuntoPivote2 );
        #local PuntoPivote3     = vnormalize( PuntoPivote3-PuntoPivote );
        #local PuntoPivote4     = vnormalize( PuntoPivote4-PuntoPivote );
        sphere                  {
          0, RadioPrincipal/4
          scale         <1,1,1/2>
          rotate        -20*x
          rotate        30*y
          matrix                <PuntoPivote3.x,PuntoPivote3.y,PuntoPivote3.z,
             PuntoPivote4.x,PuntoPivote4.y,PuntoPivote4.z,
             PuntoPivote2.x,PuntoPivote2.y,PuntoPivote2.z,
             PuntoPivote.x,PuntoPivote.y,PuntoPivote.z>
          texture   { TexturaCornea }
        }
        sphere                  {
          PuntoPivote, RadioPrincipal/16
          texture   { TexturaIris }
        }
      }
      #local C                  = C+1;
    #end
  }
#end  // #macro SRAV_SerpienteReptilAnimalVivo
                      
#macro SRAV_Serpiente( MyArreglo, AvanceLengua )
  #local L                      = SRAV_L;
  #local LargoPrincipal         = 3000*L;
  #local RadioPrincipal         = 60*L;
  #local FactorT                = 0.9;
  #local LargoCabeza            = 100*L;
  #local FactorCabeza           = 0.3;
  #local FinoCola               = 8;
  #local FactorGordo            = 0.05; 
  #local CorreccionZOjo         = 15*L;
  object        {
    SRAV_SerpienteReptilAnimalVivo
       ( MyArreglo, AvanceLengua, LargoPrincipal, RadioPrincipal, FactorT, LargoCabeza,
         FactorCabeza, CorreccionZOjo, FinoCola, FactorGordo,
         SRAV_TexturaPrincipal, SRAV_TexturaCabeza,
         SRAV_TexturaCornea, SRAV_TexturaEsclerotida, SRAV_TexturaIris, 
         SRAV_TexturaBoca, SRAV_TexturaLengua )
  }
#end