// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  1 julio 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//
// TCUV_AU2.INC
// El archivo dibuja mecates y objetos similares mediante
// interpolacion burda de normales.  No es compatible con POVRay 3.1.
// Aqui cumple la funcion de auxiliar.  Se recomienda recurrir a su
// distribucion original como AICH.inc
//
// La macro del dibujo principal tiene cuatro parametros.
// #macro TCUV_Cuerda( Estilo, ListaPuntos, ListaNormal, BanderaNormalizar ) 
//      Estilo                  : Para seleccionar el tipo de cuerda.
//              Cuatro opciones disponibles.
//                      TCUV_EstiloCable       = 10   Diametro 4*L
//                      TCUV_EstiloTriple      = 20   Diametro 4*L
//                      TCUV_EstiloMecate      = 30   Diametro 8*L
//                      TCUV_EstiloMecate2     = 40   Diametro 4*L
//      ListaPuntos             : Dato array de vectores, para ubicar los
//              puntos de control.
//      ListaNormal             : Dato array de las normales correspondientes.
//              Su tamano debe concordar con ListaPuntos.   
//              Las normales deben considerarse como guias, en realidad
//              los resultados no seran las verdaderas normales.
//      BanderaNormalizar       : La macro necesita normales unitarias.
//              Valor "on", modificar Lista Normal para normalizar.
//              Valor "off", asume que ya se encuentran normalizadas.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare TCUV_DefaultTexturaMecate
//      Textura a aplicar a los mecates.
// #declare TCUV_DefaultTexturaCable
//      Textura para el cable electrico.
// #declare TCUV_DefaultTexturaTripleCable
//      Textura para el cable para ropa.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare TCUV_TexturaCable                           = texture  { ... }
//      Textura a aplicar al cable electrico.             
// #declare TCUV_TexturaTripleCable                     = texture  { ... }
//      Textura a aplicar al cable de ropa.             
// #declare TCUV_TexturaMecate                          = texture  { ... }
//      Textura a aplicar a los mecates.             
//
// Para colocarlo requiere definir los puntos
// #include "TCUV.inc"                       
// #declare ListaPuntos = array [2]
//              { <0,0,0>,<0.1,0,0> }                                    
// #declare ListaNormales = array [2]
//              { <0,1,0>,<0,1,0> }                                    
// object        { TCUV_Cuerda( TCUV_EstiloMecate, ListaPuntos, ListaNormales, off ) }
//    
// Al usar modificadores.
// #include "TCUV.inc"                  
// #include "textures.inc"
// #declare TCUV_TexturaMecate  
//      texture         {
//        average texture_map {[0.5 Rust][0.5 TCUV_DefaultTexturaMecate]}
//      }                
// #declare ListaPuntos = array [2]
//              { <0,0,0>,<0.1,0,0> }                                    
// #declare ListaNormales = array [2]
//              { <0,1,0>,<0,1,0> }                                    
// object        { TCUV_Cuerda( TCUV_EstiloMecate, ListaPuntos, ListaNormales, off ) }
//
                             
#include "math.inc"  
#include "transforms.inc"   

#declare TCUV_Semilla           = 123;  

#declare TCUV_L                 = 0.001; 

#declare TCUV_EstiloCable       = 10; 
#declare TCUV_EstiloTriple      = 20; 
#declare TCUV_EstiloMecate      = 30;
#declare TCUV_EstiloMecate2     = 40;  
#declare TCUV_EstiloBallestrinque        = 50;

#declare TCUV_DefaultTexturaBallestrinque             =
  texture               {
    pigment { radial    
      rotate 90*x  
      frequency 3       
      pigment_map         {
        [ 0 White*2          transmit 0.2          ]
        [ 1 LightSteelBlue*2 transmit 0.9        ]
      } 
    }       
    normal                {
      quilted
      control0 1
      control1 0.5    
      scale       0.11
    }
    #ifdef ( IntensificarAmbiente )
    finish              {
      ambient   0.3
    }                            
    #end
  }   
   
#declare TCUV_TexturaBallestrinque     =
  texture  { TCUV_DefaultTexturaBallestrinque }  
  
#declare TCUV_DefaultTexturaMecate             =
  texture               {
    pigment { radial    
      rotate 90*x     
      pigment_map         {
        [ 0 Wheat         ]
        [ 1 LightWood     ]
      } 
    }       
    normal                {
      quilted
      control0 1
      control1 0.5    
      scale       0.011
    } 
  }   
  
#declare TCUV_TexturaMecate     =
  texture  { TCUV_DefaultTexturaMecate }  
  
#declare TCUV_DefaultTexturaTripleCable        =                                                
  texture               {
    pigment { radial    
      rotate 90*x     
      pigment_map         {
        [ 0   Red         ]
        [ 1/3 Red         ]
        [ 1/3 Blue        ]
        [ 2/3 Blue        ]
        [ 2/3 White       ]
        [ 1   White       ]
      }  
      rotate    30*z
    }       
    normal                {
      quilted
      control0 1
      control1 0.5    
      scale       0.011
    } 
  }    
    
#declare TCUV_DefaultTexturaCable       =    
  texture               {
    pigment { radial    
      rotate 90*x     
      pigment_map         {
        [ 0 Wheat         ]
        [ 1 White     ]
      } 
    }       
    normal                {
      quilted
      control0 1
      control1 0.5    
      scale       0.011
    } 
  }  
  
#declare TCUV_TexturaCable              =
  texture       { TCUV_DefaultTexturaCable }  
  
  
#declare TCUV_TexturaTripleCable        =
  texture       { TCUV_DefaultTexturaTripleCable }  
                                               
#macro TCUV_ObjetoMultiCilindro( TotalCilindros )
  #if ( TotalCilindros = 1 )           
    cylinder                    {
      -x, x, 1
    }
  #else  // #else ( TotalCilindros ) 
    union                       {
      #local AnguloRotador      = 360/TotalCilindros;
      #if ( TotalCilindros = 2 )
        #local RInterno         = 0.5;
      #else                           
        #local CosAngulo        = cosd( AnguloRotador );
        #local ACuad            = 1+CosAngulo;
        #local BCuad            = 2*( 1-CosAngulo );
        #local CCuad            = CosAngulo-1;
        #local RInterno         =
                ( -BCuad+sqrt( BCuad*BCuad-4*ACuad*CCuad ) )/( 2*ACuad );
      #end              
      #local C                  = 0;
      #while ( C < TotalCilindros )
        cylinder                {
          -x, x, RInterno
          translate             ( 1-RInterno )*y
          rotate                C*AnguloRotador*x
        }    
        #local C                = C+1;
      #end                                       
    }
  #end   // #else ( TotalCilindros )
#end  // #macro TCUV_ObjetiMultiCilindro

#macro TCUV_GIJ( Gij, Gji, Qi, Qj, ni, nj ) 
// Prenomalizadas
  #local DotIJ          = vdot( ni, nj );
  #local Denominador    = 9*( 5+4*DotIJ );
  #local Piv1           = 2*( Qj-Qi );
  #local PivNum         = 2*DotIJ*( nj-ni );
  #local Gij            = vdot( Piv1, nj-4*ni+PivNum )/Denominador;    
  #local Gji            = vdot( Piv1, 4*nj-ni+PivNum )/Denominador;
#end  // #macro TCUV_GIJ                                           

#macro TCUV_InterpolacionNormal( PuntoResultado, FrenteResultado, NormalResultado,
        MagnitudDerivada,
        ValorU, Punto0, Normal0, Punto1, Normal1 ) 
// La interpolacion es solo una aproximacion burda, pero simple.
// Los resultados no son ciertos ni en los puntos extremos.           
// Prenormalizadas        
  #local Gij            = 0;
  #local Gji            = 0;      
  TCUV_GIJ( Gij, Gji, Punto0, Punto1, Normal0, Normal1 )   
  #local Grupo0         = Gij*( 2*Normal0+Normal1 );
  #local Grupo1         = Gji*( Normal0+2*Normal1 );   
  #local PuntoResultado = ( 1-ValorU )*Punto0+ValorU*Punto1
        +1.5*ValorU*( 1-ValorU )*( ( 2-3*ValorU  )*Grupo0+( 3*ValorU-1 )*Grupo1 );
  #local FrenteResultado        = Punto1-Punto0
        +1.5*( ( 2-10*ValorU+9*ValorU*ValorU )*Grupo0
              +( 8*ValorU-9*ValorU*ValorU-1 )*Grupo1 ); 
  #local SegundoResultado       = 
         3*( ( -5+9*ValorU )*Grupo0+( 4-9*ValorU )*Grupo1 );
  #local MagnitudDerivada       = sqrt( vdot( FrenteResultado, FrenteResultado ) );  
  #if ( MagnitudDerivada = 0 )  
    #local FrenteResultado      = Punto1-Punto0;
    #local MagnitudDerivada     = sqrt( vdot( FrenteResultado, FrenteResultado ) );
  #end    
  #local FrenteNormalizado      = FrenteResultado/MagnitudDerivada;
  #local SegundoResultado       = SegundoResultado-
                vdot( SegundoResultado, FrenteNormalizado )*FrenteNormalizado; 
  #local MagnitudSegunda        = vlength( SegundoResultado );
  #if ( MagnitudSegunda = 0 )
    #local SegundoResultado     = Normal0+ValorU*( Normal1-Normal0 );
    #local MagnitudSegunda      = vlength( SegundoResultado );
  #end              
  #local NormalResultado        = SegundoResultado/MagnitudSegunda;                              
#end  // #macro TCUV_InterpolacionNormal       

#macro TCUV_UbicarObjeto                                   
  ( MyObjeto, Ubicacion, Frente, Normal )   
// Frente y Normal unitarios
  object                        {         
    MyObjeto
    #local Lateral              = vcross( Frente, Normal );  
    // con ese orden use Frente = x Normal = y para mantener orientacion
    Shear_Trans( Frente, Normal, Lateral )
    translate                   Ubicacion 
  }
#end  // #macro TCUV_UbicarObjeto        

#macro TCUV_ObtenerPuntosControl
  ( ValorX, ValorU, Punto0, Normal0, Punto1, Normal1, ListaPuntos, ListaNormal )
  #if ( ValorX < 0 ) 
    #local Control              = 0;
  #else                             
    #if ( ValorX >= ( dimension_size( ListaPuntos, 1 )-1.5 ) )
      #local Control            = dimension_size( ListaPuntos, 1 )-2;
    #else                                                       
      #local Control            = floor( ValorX );
    #end 
  #end  
  #local Punto0                 = ListaPuntos[Control];
  #local Normal0                = ListaNormal[Control];
  #local Punto1                 = ListaPuntos[Control+1];
  #local Normal1                = ListaNormal[Control+1];
  #local ValorU                 = ValorX-Control;
#end  // #macro TCUV_ObtenerPuntosControl  

#macro TCUV_GenerarCuerdaGruesa
  ( MyObjeto, ListaPuntos, ListaNormal, XInicial, XFinal, DistanciaControl,
    AnguloInicial, GiroDistancia )      
  union                         {  
    #local ValorU               = 0;
    #local ValorX               = XInicial;
    #local Punto0               = <0,0,0>;
    #local Punto1               = <0,0,0>;
    #local PuntoResultado       = <0,0,0>;
    #local NormalResultado      = <0,0,0>;
    #local FrenteResultado      = <0,0,0>;
    #local Normal0              = <0,0,0>;
    #local Normal1              = <0,0,0>;
    #local MagnitudDerivada     = 0;    
    #local AnguloRotar          = AnguloInicial;
    #while ( ValorX <= XFinal )
      #local MagnitudDerivada       = 0;
      TCUV_ObtenerPuntosControl
       ( ValorX, ValorU, Punto0, Normal0, Punto1, Normal1, ListaPuntos, ListaNormal )
      TCUV_InterpolacionNormal( PuntoResultado, FrenteResultado, NormalResultado,
         MagnitudDerivada, ValorU, Punto0, Normal0, Punto1, Normal1 )               
      #local FrenteResultado        = FrenteResultado/MagnitudDerivada;
      #local NormalResultado        =
        vaxis_rotate( NormalResultado, FrenteResultado, AnguloRotar );   
      TCUV_UbicarObjeto( MyObjeto, PuntoResultado, FrenteResultado, NormalResultado )   
      #local DeltaX                 =  
           min( +0.5*DistanciaControl/MagnitudDerivada, +1 );         
      #local AnguloRotar            = AnguloRotar+
                        MagnitudDerivada*DeltaX*GiroDistancia;
      #local ValorX                 = ValorX+DeltaX;     
    #end  // #while ( ValorX < XFinal )  
  }   
#end  // #macro TCUV_GenerarCuerdaGruesa 
 
#macro TCUV_GenerarCuerdaGruesa
  ( MyObjeto, ListaPuntos, ListaNormal, XInicial, XFinal, DistanciaControl,
    AnguloInicial, GiroDistancia )      
  union                         {  
    #local ValorU               = 0;
    #local ValorX               = XInicial;
    #local Punto0               = <0,0,0>;
    #local Punto1               = <0,0,0>;
    #local PuntoResultado       = <0,0,0>;
    #local NormalResultado      = <0,0,0>;
    #local FrenteResultado      = <0,0,0>;
    #local Normal0              = <0,0,0>;
    #local Normal1              = <0,0,0>;
    #local MagnitudDerivada     = 0;    
    #local AnguloRotar          = AnguloInicial;
    #while ( ValorX <= XFinal )
      #local MagnitudDerivada       = 0;
      TCUV_ObtenerPuntosControl
       ( ValorX, ValorU, Punto0, Normal0, Punto1, Normal1, ListaPuntos, ListaNormal )
      TCUV_InterpolacionNormal( PuntoResultado, FrenteResultado, NormalResultado,
         MagnitudDerivada, ValorU, Punto0, Normal0, Punto1, Normal1 )               
      #local FrenteResultado        = FrenteResultado/MagnitudDerivada;
      #local NormalResultado        =
        vaxis_rotate( NormalResultado, FrenteResultado, AnguloRotar );  
      TCUV_UbicarObjeto( MyObjeto, PuntoResultado, FrenteResultado, NormalResultado )   
      #local DeltaX                 =  
           min( +0.5*DistanciaControl/MagnitudDerivada, +1 );         
      #local AnguloRotar            = AnguloRotar+
                        MagnitudDerivada*DeltaX*GiroDistancia;
      #local ValorX                 = ValorX+DeltaX;     
    #end  // #while ( ValorX < XFinal )  
  }   
#end  // #macro TCUV_GenerarCuerdaGruesa

#macro TCUV_Cuerda( Estilo, ListaPuntos, ListaNormal, BanderaNormalizar ) 
  object                        {   
    #if ( BanderaNormalizar )
      #local C                  = 0;
      #while ( C < dimension_size( ListaPuntos, 1 ) ) 
        #local ListaNormal[C]   = vnormalize( ListaNormal[C] );
        #local C                = C+1;
      #end
    #end                    
    #switch ( Estilo )
      #case ( TCUV_EstiloTriple )     
        #declare TCUV_ObjetoCable    =  
      object                    {
        TCUV_ObjetoMultiCilindro(3)
        scale    0.05   
        rotate        90*y    
        texture               { 
          TCUV_TexturaTripleCable
        } 
  
        rotate                90*y
        scale         <0.25,0.75,1>  
        scale           2*TCUV_L/0.05   
      }      
        #declare TCUV_Vueltas  = 360*80;                  
      #break 
      #case ( TCUV_EstiloCable )
        #declare TCUV_ObjetoCable    =     
      object                    {
        TCUV_ObjetoMultiCilindro(2)
        scale    0.05   
        rotate        90*y    
        texture               { 
          TCUV_TexturaCable
        } 
  
        rotate                90*y
        scale         <0.25,0.75,1>  
        scale           2*TCUV_L/0.05   
      }      
        #declare TCUV_Vueltas  = 360*20;                  
      #break   
      #case ( TCUV_EstiloMecate ) 
      #declare TCUV_ObjetoCable    =   
      object                    {
        TCUV_ObjetoMultiCilindro(6)
        scale    0.05   
        rotate        90*y    
        texture               { 
          TCUV_TexturaMecate
        } 
  
        rotate                90*y
        scale         <0.25,1.50,2>  
        scale           2*TCUV_L/0.05   
      }   
        #declare TCUV_Vueltas  = 360*45; 
                        
      #break
      #case ( TCUV_EstiloMecate2 )
        #declare TCUV_ObjetoCable    =  
      object                    {
        TCUV_ObjetoMultiCilindro(10)
        scale    0.05   
        rotate        90*y    
        texture               { 
          TCUV_TexturaMecate
        } 
  
        rotate                90*y
        scale         <0.25,0.75,1>  
        scale           2*TCUV_L/0.05   
      }      
        #declare TCUV_Vueltas  = 360*120;                  
      #break  
      #case ( TCUV_EstiloBallestrinque ) 
      #declare TCUV_ObjetoCable    =   
      object                    {  
        TCUV_ObjetoMultiCilindro(3)
        scale    0.05   
        rotate        90*y    
        texture               { 
          TCUV_TexturaBallestrinque
        } 
  
        rotate                90*y
        scale         <0.25,0.75,1>  
        scale           2*TCUV_L/0.05   
      }   
        #declare TCUV_Vueltas  = 360*30; 
                        
      #break      
   #end   
   TCUV_GenerarCuerdaGruesa
     ( TCUV_ObjetoCable, ListaPuntos, ListaNormal, 
           0, dimension_size( ListaPuntos, 1 )-1, 2*0.025*TCUV_L/0.05,
        0, TCUV_Vueltas )            
  }
#end  // #macro TCUV_CableElectrico 