// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  29 enero 2014
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//
// TPPR TelevisorPlanoPovRay
// El archivo dibuja un televisor Pantalla Plana como se han popularizado
// en Costa Rica ultimamente.
// Permite agregar imagenes en la pantalla con facilidad, aparte de
// otras modificaciones.
//
// La macro default tiene cuatro parametros
// #macro TPPR_Televisor( BanderaEncendido, Imagen,
//              TurbulenciaImagen, BanderaBase )
//      BanderaEncendido        : "off" apaga el televisor, "on" lo enciende.
//              Imagen y TurbulenciaImagen se ignoran si apaga el televisor.
//      Imagen                  : Imagen GIF a dibujar en pantalla.  Para
//              emplear otro tipo de imagen, consulte los modificadores.
//      TurbulenciaImagen       : Para agregar algo de turbulencia a la
//              imagen.  Utilice valores en milesimos, un valor de
//              0.005 o cero funcionaran bien.  Puede usar un vector.
//      BanderaBase             : "false" no dibuja la base del televisor,
//              "true" si la dibuja.
//
// Las dimensiones del televisor default serian:
//      Alto total              =   390*L
//      Alto base               =    40*L
//      Frente total            =   550*L
//      Profundidad Z           =  -108*L.. 80*L
//      Profundidad sin base    =  - 14*L.. 66*L
// Se dibuja sobre el plano XZ hemisferio Y positivo,
// parcialmente centrado en el origen.
// El frente sobresale en direccion Z-, con gravedad Y-.
//
// La siguiente macro permite mayor flexibilidad:
// #macro TPPR_TelevisorPlanoPovRay(
//              BanderaEncendido, Imagen, TurbulenciaImagen,
//              AltoPrincipal, FrentePrincipal, ProfundidadPrincipal,
//              BordePrincipal, BordeInferior,
//              ProfundidadBorde, ProfundidadVisor, CizallaUsual,
//              AltoBase, AltoPlacaBase,
//              TexturaTelevisorApagado, TexturaTelevisorEncendido,
//              TexturaBorde, TexturaPosterior,
//              MaterialInfrarrojo, MaterialIndicadorEncendido )
//      BanderaEncendido        : "off" apaga el televisor, "on" lo enciende.
//              Imagen y TurbulenciaImagen se ignoran si apaga el televisor.
//      Imagen                  : Imagen GIF a dibujar en pantalla.  Para
//              emplear otro tipo de imagen, consulte los modificadores.
//      TurbulenciaImagen       : Para agregar algo de turbulencia a la
//              imagen.  Utilice valores en milesimos, un valor de
//              0.005 o cero funcionaran bien.  Puede usar un vector.
//      AltoPrincipal           : Alto del televisor sin la base.
//              Default es 350*L.
//      FrentePrincipal         : Frente X del televisor.  Default es 550*L.
//      ProfundidadPrincipal    : Profundidad Z total del televisor sin base.
//              Default es 80*L.
//      BordePrincipal          : Medidad del marco superior y lateral
//              para la imagen del televisor.  Default es 27*L.
//      BordeInferior           : Borde extra del marco inferior
//              del televisor, para ubicar los botones.  Default es 20*L.
//      ProfundidadBorde        : Profundidad Z asignada al marco frontal
//              del televisor.  Este marco sobresale del plano XY hacia Z-.
//              Default es 14*L.
//      ProfundidadVisor        : Hundimiento Z de la pantalla respecto
//              al marco.  Default es 4.3*L.
//      CizallaUsual            : Valor de referencia para recortes
//              angulares decorativos.  Default es 3*L.
//      AltoBase                : Utilice 0 para no dibujar la base del todo.
//              Alto de base adicional al total del televisor.
//              Default es 40*L.
//      AltoPlacaBase           : Alto de la placa plana inferior de la base.
//              Default es 11*L.
//      TexturaTelevisorApagado : Textura para aplicar a la pantalla apagada.
//              Default es TPPR_TexturaTelevisorApagado.
//      TexturaTelevisorEncendido               : Textura para aplicar sobre
//              la imagen del televisor Encendido.  Deberia tener elevada
//              transparencia.  O bien si lo prefiere, podria tapar
//              completamente la imagen, y sustituirlo por su propio proceso.
//              Default es TPPR_TexturaTelevisorEncendido.
//      TexturaBorde            : Textura principal del televisor, que
//              se aplica al marco.  Default es TPPR_TexturaBorde.
//      TexturaPosterior        : Textura a aplicar a la zona posterior
//              del televisor.  Default es TPPR_TexturaPosterior.
//      MaterialInfrarrojo      : Material a aplicar al lector de infrarrojo.
//              Default es TPPR_MaterialInfrarrojo.
//      MaterialIndicadorEncendido              : Material a aplicar al
//              indicador de encendido.
//              Default es TPPR_MaterialIndicadorEncendido.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare TPPR_SYS               = 0;
//      Selector para TPPR_TipoImagen, corresponde al formato de imagen
//      propio del sistema operativo.
// #declare TPPR_GIF               = 1;
//      Selector para TPPR_TipoImagen, corresponde al tipo GIF.
// #declare TPPR_JPEG              = 2;
//      Selector para TPPR_TipoImagen, corresponde al tipo JPEG.
// #declare TPPR_TGA               = 3;
//      Selector para TPPR_TipoImagen, corresponde al tipo TGA.
// #declare TPPR_PNG               = 4;
//      Selector para TPPR_TipoImagen, corresponde al tipo PNG.
// #declare TPPR_DefaultTexturaTelevisorApagado
//      Textura para aplicar a la pantalla apagada.
// #declare TPPR_DefaultTexturaTelevisorEncendido
//      Textura para aplicar sobre la imagen del televisor encendido.
//      Deberia tener elevada transparencia.  O bien si lo prefiere,
//      podria tapar completamente la imagen, y sustituirlo
//      por su propio proceso.
// #declare TPPR_DefaultTexturaBorde
//      Textura principal del televisor, que se aplica al marco.
// #declare TPPR_DefaultTexturaPosterior
//      Textura a aplicar a la zona posterior del televisor.
// #declare TPPR_DefaultMaterialInfrarrojo
//      Material a aplicar al lector de infrarrojo.
// #declare TPPR_DefaultMaterialIndicadorEncendido
//      Material a aplicar al indicador de encendido.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare TPPR_TipoImagen                             = TPPR_GIF;
//      Para asignar el tipo de imagen a pasar al televisor.
//      Los selectores predefinidos son: TPPR_SYS, TPPR_GIF,
//      TPPR_JPEG, TPPR_TGA y TPPR_PNG.
// #declare TPPR_TexturaTelevisorApagado                = texture  { ... }
//      Textura para aplicar a la pantalla apagada.
// #declare TPPR_TexturaTelevisorEncendido              = texture  { ... }
//      Textura para aplicar sobre la imagen del televisor encendido.
//      Deberia tener elevada transparencia.  O bien si lo prefiere,
//      podria tapar completamente la imagen, y sustituirlo
//      por su propio proceso.
// #declare TPPR_TexturaBorde                           = texture  { ... }
//      Textura principal del televisor, que se aplica al marco.
// #declare TPPR_TexturaPosterior                       = texture  { ... }
//      Textura a aplicar a la zona posterior del televisor.
// #declare TPPR_MaterialInfrarrojo                     = material { ... }
//      Material a aplicar al lector de infrarrojo.
// #declare TPPR_MaterialIndicadorEncendido             = material { ... }
//      Material a aplicar al indicador de encendido.
// #declare HEDA_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "TPPR.inc"
// object        { TPPR_Televisor( on, "custom.gif", 0.005, true ) }
//
// Otro ejemplo con modificador
// #include "TPPR.inc"
// #declare TPPR_TexturaBorde        = texture       {
//   average
//   texture_map        {
//     [ 0.5 TPPR_DefaultTexturaBorde ]
//     [ 0.5 Rust                         ]
//   }
// }
// object        {
//   TPPR_Televisor( on, "custom.gif", 0.005, true )
// }
//
// Un ejemplo con la macro detallada
// #include "TPPR.inc"
// object               {
//   TPPR_TelevisorPlanoPovRay( on, "custom.gif", 0.005,
//        0.350, 0.550, 0.080, 0.027, 0.020,
//        0.014, 0.0043, 0.003, 0.040, 0.011,
//        TPPR_TexturaTelevisorApagado, TPPR_TexturaTelevisorEncendido,
//        TPPR_TexturaBorde, TPPR_TexturaPosterior,
//        TPPR_MaterialInfrarrojo, TPPR_MaterialIndicadorEncendido )
// }
//


#include "finish.inc"
#include "textures.inc"

#declare TPPR_L                 = 0.001;

#declare TPPR_SYS               = 0;
#declare TPPR_GIF               = 1;
#declare TPPR_JPEG              = 2;
#declare TPPR_TGA               = 3;
#declare TPPR_PNG               = 4;

#declare TPPR_TipoImagen        = TPPR_GIF;

#if ( version < 3.2 )
  #ifndef( TPPR_POV3_1 )
    #declare TPPR_POV3_1        = on;
  #end
#else
  #ifndef( TPPR_POV3_1 )
    #declare TPPR_POV3_1        = off;
  #end
#end

#declare TPPR_DefaultTexturaBorde       =
  texture                               {
    pigment                             {
      color     < 0.100, 0.100, 0.120 >
    }
    normal                              {
      bumps             0.15
    }
    finish                              {
      Phong_Glossy
    }
  }

#declare TPPR_DefaultTexturaTelevisorApagado       =
  texture                               {
    pigment                             {
      color     < 0.100, 0.100, 0.150 >
    }
    normal                              {
      bumps             0.5
      scale             1
    }
    finish                              {
      Glossy
    }
  }

#declare TPPR_DefaultTexturaTelevisorEncendido       =
  texture                               {
    pigment                             {
      color     White transmit 0.975
    }
    finish                              {
   //   metallic
    //  phong              0.1
    //  phong_size         10
   //   ambient           0.0
      specular          0.4
    }
  }



#declare TPPR_DefaultTexturaPosterior   =
  texture                               {
    pigment                             {
      color     < 0.200, 0.200, 0.240 >
    }
    normal                              {
      bumps
      scale             0.01
    }
    finish                              {
      metallic
    }
  }

#declare TPPR_DefaultMaterialInfrarrojo =
  material                              {
    texture { Glass2 }
  }

#declare TPPR_DefaultMaterialIndicadorEncendido =
  material                              {
    texture {
      pigment { Red }
      finish {
        phong   2
        phong_size      100
        metallic
        ambient  0.05
        reflection      0.95
      }
    }
  }

#ifndef ( TPPR_TexturaBorde )
  #declare TPPR_TexturaBorde            = TPPR_DefaultTexturaBorde
#end  // #ifndef ( TPPR_TexturaBorde )

#ifndef ( TPPR_TexturaTelevisorApagado )
  #declare TPPR_TexturaTelevisorApagado = TPPR_DefaultTexturaTelevisorApagado
#end  // #ifndef ( TPPR_TexturaBorde )

#ifndef ( TPPR_TexturaTelevisorEncendido )
  #declare TPPR_TexturaTelevisorEncendido = TPPR_DefaultTexturaTelevisorEncendido
#end  // #ifndef ( TPPR_TexturaBorde )


#ifndef ( TPPR_TexturaPosterior )
  #declare TPPR_TexturaPosterior        = TPPR_DefaultTexturaPosterior
#end  // #ifndef ( TPPR_TexturaBorde )

#ifndef ( TPPR_MaterialInfrarrojo )
  #declare TPPR_MaterialInfrarrojo      = TPPR_DefaultMaterialInfrarrojo
#end

#ifndef ( TPPR_MaterialIndicadorEncendido )
  #declare TPPR_MaterialIndicadorEncendido      =
                TPPR_DefaultMaterialIndicadorEncendido
#end



#macro TPPR_TelevisorPlanoPovRay( BanderaEncendido, Imagen, TurbulenciaImagen,
      AltoPrincipal, FrentePrincipal, ProfundidadPrincipal,
      BordePrincipal, BordeInferior,
      ProfundidadBorde, ProfundidadVisor, CizallaUsual,
      AltoBase, AltoPlacaBase,
      TexturaTelevisorApagado, TexturaTelevisorEncendido,
      TexturaBorde, TexturaPosterior,
      MaterialInfrarrojo, MaterialIndicadorEncendido )
  union                         {
    // Por diferencia se define el borde frontal y la pantalla
    difference                  {
      // El Borde frontal lo definimos (con exceso)
      // por intersection de tres prismas
      intersection              {
        // Este es el prisma que define la vista del frente
        // lo definimos inicialmente centrado FrentePrincipal y AltoPrincipal
        prism                   {
          -ProfundidadBorde, 2*ProfundidadBorde
          7,
          <-FrentePrincipal/2, +AltoPrincipal/2                         >,
          <+FrentePrincipal/2, +AltoPrincipal/2                         >,
          <+FrentePrincipal/2, -AltoPrincipal/2+BordeInferior           >,
          <+FrentePrincipal/2-BordeInferior/tan(pi/3), -AltoPrincipal/2 >,
          <-FrentePrincipal/2+BordeInferior/tan(pi/3), -AltoPrincipal/2 >,
          <-FrentePrincipal/2, -AltoPrincipal/2+BordeInferior           >,
          <-FrentePrincipal/2, +AltoPrincipal/2                         >
          rotate                -90*x
        }  // prism
        // Prisma que define la vista lateral del borde frontal
        #local PrismaLateral    =
        prism                   {
          -FrentePrincipal, FrentePrincipal
          7,
          < 0, +AltoPrincipal/2                                         >,
          < ProfundidadBorde, +AltoPrincipal/2-CizallaUsual             >,
          < ProfundidadBorde,-AltoPrincipal/2+CizallaUsual+BordeInferior>,
          < ProfundidadBorde-CizallaUsual,-AltoPrincipal/2+BordeInferior>,
          < ProfundidadBorde+CizallaUsual,-AltoPrincipal/2+BordeInferior/3>,
          < 0, -AltoPrincipal/2                                         >,
          < 0, +AltoPrincipal/2                                         >
          rotate                -90*x
          rotate                90*y
        }
        object                  {
          PrismaLateral
        }
        // Este es el prisma de vista superior poco interesante
        // resulta algo equivoco en el borde inferior lastima...
        prism                   {
          -AltoPrincipal, AltoPrincipal
          5,
          <-FrentePrincipal/2, -0.01*ProfundidadBorde                   >,
          <-FrentePrincipal/2+2*CizallaUsual, ProfundidadBorde+CizallaUsual       >,
          <+FrentePrincipal/2-2*CizallaUsual, ProfundidadBorde+CizallaUsual       >,
          <+FrentePrincipal/2, -0.01*ProfundidadBorde                   >,
          <-FrentePrincipal/2, -0.01*ProfundidadBorde                   >
          rotate                180*y
        }

        box                      {
          <-FrentePrincipal/2+BordePrincipal,
           -AltoPrincipal/2+BordePrincipal+BordeInferior,
           -1.1*ProfundidadBorde>,
          <+FrentePrincipal/2-BordePrincipal,
           +AltoPrincipal/2-BordePrincipal,
           -ProfundidadBorde+0.999*ProfundidadVisor >
           inverse
        }
        box                      {
          <-FrentePrincipal/2+1.01*BordePrincipal,
           -AltoPrincipal/2+1.01*BordePrincipal+BordeInferior,
           -1.1*ProfundidadBorde>,
          <+FrentePrincipal/2-1.01*BordePrincipal,
           +AltoPrincipal/2-1.01*BordePrincipal,
           -ProfundidadBorde+ProfundidadVisor >
          inverse
          #if ( BanderaEncendido )
            texture                     {
              pigment                   {
               image_map                {
                 #switch ( TPPR_TipoImagen )
                   #case ( TPPR_SYS )
                     sys        Imagen
                   #break
                   #case ( TPPR_GIF )
                     gif        Imagen
                   #break
                   #case ( TPPR_JPEG )
                     jpeg       Imagen
                   #break
                   #case ( TPPR_TGA )
                     tga        Imagen
                   #break
                   #case ( TPPR_PNG )
                     png        Imagen
                   #break
                   #else
                     #error "Formato imagen incorrecto\n"
                 #end
                 once
               }
               turbulence               TurbulenciaImagen
               translate      -0.5*x-0.5*y
               scale          < FrentePrincipal-2*BordePrincipal,
                                  AltoPrincipal-2*BordePrincipal-BordeInferior >
               translate      +BordeInferior/2*y

              }
            }
            texture              {
              TexturaTelevisorEncendido
            }
          #else
            texture               {
              TexturaTelevisorApagado
            }
          #end
        }

        box                         {
          <   FrentePrincipal/20, 16*BordeInferior/18,-ProfundidadBorde/2>,
          < 3*FrentePrincipal/40, 8*BordeInferior/18,-2*ProfundidadBorde>
          translate                 -AltoPrincipal/2*y-FrentePrincipal/2*x
          inverse
        }

        cylinder                    {
          -ProfundidadBorde/2*z, -2*ProfundidadBorde*z,  BordeInferior/12
          translate                 2*BordeInferior/3*y+FrentePrincipal/10*x
          translate                 -AltoPrincipal/2*y-FrentePrincipal/2*x
          inverse
        }
        texture                 {
          TexturaBorde
        }
      }
      translate                 AltoPrincipal/2*y+AltoBase*y
    }  // difference
    #if ( BanderaEncendido )
      light_source              {
        0, Red*2
        spotlight
        point_at                z
        translate               -1.2*ProfundidadBorde*z
        translate                 2*BordeInferior/3*y+FrentePrincipal/10*x
        translate                 -AltoPrincipal/2*y-FrentePrincipal/2*x
        translate                 AltoPrincipal/2*y+AltoBase*y
      }
      #if ( TPPR_POV3_1 )
      light_source                {
        (-ProfundidadBorde+0.9*ProfundidadVisor)*z
        White*1
        area_light
        (FrentePrincipal-4*BordePrincipal)*x,(AltoPrincipal-4*BordePrincipal-BordeInferior)*y,9,9
        adaptive 1
        translate                 AltoPrincipal/2*y+AltoBase*y
      }
      #else  
      light_source                {
        -2*ProfundidadBorde*z
        Gray50
        parallel
        point_at          0
        projected_through         {
          box                      {
            <-FrentePrincipal/2+1.01*BordePrincipal,
             -AltoPrincipal/2+1.01*BordePrincipal+BordeInferior,
             -1.1*ProfundidadBorde>,
            <+FrentePrincipal/2-1.01*BordePrincipal,
             +AltoPrincipal/2-1.01*BordePrincipal,
             -1.2*ProfundidadBorde >
          }
        }
        translate                 AltoPrincipal/2*y+AltoBase*y
      }
      #end
    #end
    intersection                {
      object                    {
        PrismaLateral
        scale           <1,1,1.01>
      }
      box                         {
        <   FrentePrincipal/20, 16*BordeInferior/18,-ProfundidadBorde/2>,
        < 3*FrentePrincipal/40, 8*BordeInferior/18,-2*ProfundidadBorde>
        translate                 -AltoPrincipal/2*y-FrentePrincipal/2*x
      }
      material              {
        MaterialInfrarrojo
      }
      translate                 AltoPrincipal/2*y+AltoBase*y
    }
    intersection                {
      object                    {
        PrismaLateral
        scale           <1,1,1.01>
      }
      cylinder                    {
        -ProfundidadBorde/2*z, -2*ProfundidadBorde*z,  BordeInferior/12
        translate                 2*BordeInferior/3*y+FrentePrincipal/10*x
        translate                 -AltoPrincipal/2*y-FrentePrincipal/2*x
      } 
      #if ( BanderaEncendido )   
        material            {
          MaterialIndicadorEncendido
        }
      #else
        material            {
          MaterialInfrarrojo
        }
      #end
      translate                 AltoPrincipal/2*y+AltoBase*y
    }
    // Ahora generamos la base
    #if ( !( AltoBase = 0 ) )
      #local FrenteBase         = 250*FrentePrincipal/550;
      #local ProfundidadBase    = 187.5*ProfundidadPrincipal/80;
      #local RecorteInferior    = 11*FrentePrincipal/550;
      #local RadioCilindroBase  = 30.5*( ProfundidadPrincipal-ProfundidadBorde )/66;
      union                     {
        box                     {
          < -FrenteBase/2+RecorteInferior, 0,
                    -ProfundidadBase/2+RecorteInferior >,
          <  FrenteBase/2-RecorteInferior, AltoPlacaBase*5/11,
                    +ProfundidadBase/2-RecorteInferior >
        }
        box                     {
          < -FrenteBase/2, AltoPlacaBase*5/11, -ProfundidadBase/2 >,
          <  FrenteBase/2, AltoPlacaBase*7/11, +ProfundidadBase/2 >
        }
        prism                   {
          conic_sweep
          1, 1-4/200,
          5
          < -FrenteBase/2, -ProfundidadBase/2 >,
          < +FrenteBase/2, -ProfundidadBase/2 >,
          < +FrenteBase/2, +ProfundidadBase/2 >,
          < -FrenteBase/2, +ProfundidadBase/2 >,
          < -FrenteBase/2, -ProfundidadBase/2 >
          translate             -y
          scale                 <1,-200/4*(AltoPlacaBase*4/11),1>
          translate             AltoPlacaBase*7/11*y
        }
        #local FactorCilindro   = 1/20;
        prism                   {
          cubic_spline
          conic_sweep
          1, 1-FactorCilindro,
          7,
          < -RadioCilindroBase, 0 >,
          < 0, +RadioCilindroBase >,
          < +RadioCilindroBase, 0 >,
          < 0, -RadioCilindroBase*1.10 >,
          < -RadioCilindroBase, 0 >,
          < 0, +RadioCilindroBase >,
          < +RadioCilindroBase, 0 >
          translate             -y
          scale                 <1,-1.50*AltoBase/FactorCilindro, 1 >
          translate             AltoPlacaBase*y+ProfundidadBase/10*z

        }
        translate               -ProfundidadBase/10*z
           +( ProfundidadPrincipal-ProfundidadBorde )*z/2
        texture                 {
          TexturaBorde
        }
      }
    #end
    // Definimos ahora las capas posteriores

    union                       {
      #local Nivel0             = 1/300;
      #local Nivel1             = 1/50;
      #local Nivel2             = 1/40;
      #local Nivel3             = 1/10;
      #local Nivel4             = 1/5;
      #local Profundidad0       =
               18*( ProfundidadPrincipal-ProfundidadBorde )/66;
      #local Profundidad1       =
               29*( ProfundidadPrincipal-ProfundidadBorde )/66;
      prism                   {
        conic_sweep
        1-Nivel0, 1-Nivel1,
        7,
        <-FrentePrincipal/2, +AltoPrincipal/2                         >,
        <+FrentePrincipal/2, +AltoPrincipal/2                         >,
        <+FrentePrincipal/2, -AltoPrincipal/2+BordeInferior           >,
        <+FrentePrincipal/2-BordeInferior/tan(pi/3), -AltoPrincipal/2 >,
        <-FrentePrincipal/2+BordeInferior/tan(pi/3), -AltoPrincipal/2 >,
        <-FrentePrincipal/2, -AltoPrincipal/2+BordeInferior           >,
        <-FrentePrincipal/2, +AltoPrincipal/2                         >
        translate             -(1-1.01*Nivel0 )*y
        scale                 <1,-Profundidad0/( Nivel1-Nivel0 ), 1 >
        rotate                90*x
        translate             Nivel0*AltoPrincipal/2*y
      }  // prism
      prism                   {
        conic_sweep
        1-Nivel2, 1-Nivel3,
        7,
        <-FrentePrincipal/2, +AltoPrincipal/2                         >,
        <+FrentePrincipal/2, +AltoPrincipal/2                         >,
        <+FrentePrincipal/2, -AltoPrincipal/2+BordeInferior           >,
        <+FrentePrincipal/2-BordeInferior/tan(pi/3), -AltoPrincipal/2 >,
        <-FrentePrincipal/2+BordeInferior/tan(pi/3), -AltoPrincipal/2 >,
        <-FrentePrincipal/2, -AltoPrincipal/2+BordeInferior           >,
        <-FrentePrincipal/2, +AltoPrincipal/2                         >
        translate             -(1-1.01*Nivel2 )*y
        scale                 <1,-1/( Nivel3-Nivel2 ), 1 >
        matrix                <1,0,0,
                               0,1,AltoPrincipal/20,
                               0,0,1,
                               0,0,0>
        scale                 <1,Profundidad1,1>
        rotate                90*x
        translate             Nivel2*AltoPrincipal*y/2+Profundidad0*z
      }  // prism
      difference                {
        superellipsoid            {
          <0.1,0.1>
          scale           <FrentePrincipal/3,AltoPrincipal/10,
                                58*(ProfundidadPrincipal-ProfundidadBorde)/66 >
          translate       +AltoPrincipal/10*y
          translate       -0.95*AltoPrincipal/2*y
        }
        plane                   {
          z, 0
        }
      }
      difference                {
        prism                   {
          linear_spline
          conic_sweep
          1, 1-Nivel4,
          9,
          <-FrentePrincipal/4,-AltoPrincipal/4>,
          <+FrentePrincipal/4,-AltoPrincipal/4>,
          <+FrentePrincipal/4,-AltoPrincipal/8>,
          <+FrentePrincipal/2,-AltoPrincipal/8>,
          <+FrentePrincipal/2,+AltoPrincipal/5>,
          <+FrentePrincipal/4,+AltoPrincipal/5>,
          <+FrentePrincipal/4,+AltoPrincipal/2>,
          <-FrentePrincipal/4,+AltoPrincipal/2>,
          <-FrentePrincipal/4,-AltoPrincipal/4>
          translate             -y
          scale                 <-1,-(ProfundidadPrincipal-ProfundidadBorde)/Nivel4, 1 >
          rotate                90*x
        }
      }
      translate                 AltoBase*y+AltoPrincipal/2*y
      texture                   {
        TexturaPosterior
      }
    }
  }  // union
#end  // #macro

#macro TPPR_Televisor( BanderaEncendido, Imagen, TurbulenciaImagen, BanderaBase )
  object                        {
    #local L                    = TPPR_L;
    #local AltoPrincipal        = 350*L;
    #local FrentePrincipal      = 550*L;
    #local ProfundidadPrincipal = 80*L;
    #local BordePrincipal       = 27*L;
    #local BordeInferior        = 20*L;
    #local CizallaUsual         = 3*L;
    #local ProfundidadBorde     = 14*L;
    #local ProfundidadVisor     = 4.3*L;
    #if ( BanderaBase )
      #local AltoBase           = 40*L;
      #local AltoPlacaBase      = 11*L;
    #else
      #local AltoBase           = 0*L;
      #local AltoPlacaBase      = 0*L;
    #end
    TPPR_TelevisorPlanoPovRay( BanderaEncendido, Imagen, TurbulenciaImagen,
      AltoPrincipal, FrentePrincipal, ProfundidadPrincipal,
      BordePrincipal, BordeInferior,
      ProfundidadBorde, ProfundidadVisor, CizallaUsual,
      AltoBase, AltoPlacaBase,
      TPPR_TexturaTelevisorApagado, TPPR_TexturaTelevisorEncendido,
      TPPR_TexturaBorde, TPPR_TexturaPosterior,
      TPPR_MaterialInfrarrojo, TPPR_MaterialIndicadorEncendido )
  }
#end  // #macro
