// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  29 enero 2014
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//
// TPPR TelevisorPlanoPovRay
// El archivo dibuja un televisor Pantalla Plana como se han popularizado
// en Costa Rica ultimamente.
// Permite agregar imagenes en la pantalla con facilidad, aparte de
// otras modificaciones.
//
// La macro default tiene cuatro parametros
// #macro TPPR_Televisor( BanderaEncendido, Imagen,
//              TurbulenciaImagen, BanderaBase )
//      BanderaEncendido        : "off" apaga el televisor, "on" lo enciende.
//              Imagen y TurbulenciaImagen se ignoran si apaga el televisor.
//      Imagen                  : Imagen GIF a dibujar en pantalla.  Para
//              emplear otro tipo de imagen, consulte los modificadores.
//      TurbulenciaImagen       : Para agregar algo de turbulencia a la
//              imagen.  Utilice valores en milesimos, un valor de
//              0.005 o cero funcionaran bien.  Puede usar un vector.
//      BanderaBase             : "false" no dibuja la base del televisor,
//              "true" si la dibuja.
//
// Las dimensiones del televisor default serian:
//      Alto total              =   390*L
//      Alto base               =    40*L
//      Frente total            =   550*L
//      Profundidad Z           =  -108*L.. 80*L
//      Profundidad sin base    =  - 14*L.. 66*L
// Se dibuja sobre el plano XZ hemisferio Y positivo,
// parcialmente centrado en el origen.
// El frente sobresale en direccion Z-, con gravedad Y-.
//
// La siguiente macro permite mayor flexibilidad:
// #macro TPPR_TelevisorPlanoPovRay(
//              BanderaEncendido, Imagen, TurbulenciaImagen,
//              AltoPrincipal, FrentePrincipal, ProfundidadPrincipal,
//              BordePrincipal, BordeInferior,
//              ProfundidadBorde, ProfundidadVisor, CizallaUsual,
//              AltoBase, AltoPlacaBase,
//              TexturaTelevisorApagado, TexturaTelevisorEncendido,
//              TexturaBorde, TexturaPosterior,
//              MaterialInfrarrojo, MaterialIndicadorEncendido )
//      BanderaEncendido        : "off" apaga el televisor, "on" lo enciende.
//              Imagen y TurbulenciaImagen se ignoran si apaga el televisor.
//      Imagen                  : Imagen GIF a dibujar en pantalla.  Para
//              emplear otro tipo de imagen, consulte los modificadores.
//      TurbulenciaImagen       : Para agregar algo de turbulencia a la
//              imagen.  Utilice valores en milesimos, un valor de
//              0.005 o cero funcionaran bien.  Puede usar un vector.
//      AltoPrincipal           : Alto del televisor sin la base.
//              Default es 350*L.
//      FrentePrincipal         : Frente X del televisor.  Default es 550*L.
//      ProfundidadPrincipal    : Profundidad Z total del televisor sin base.
//              Default es 80*L.
//      BordePrincipal          : Medidad del marco superior y lateral
//              para la imagen del televisor.  Default es 27*L.
//      BordeInferior           : Borde extra del marco inferior
//              del televisor, para ubicar los botones.  Default es 20*L.
//      ProfundidadBorde        : Profundidad Z asignada al marco frontal
//              del televisor.  Este marco sobresale del plano XY hacia Z-.
//              Default es 14*L.
//      ProfundidadVisor        : Hundimiento Z de la pantalla respecto
//              al marco.  Default es 4.3*L.
//      CizallaUsual            : Valor de referencia para recortes
//              angulares decorativos.  Default es 3*L.
//      AltoBase                : Utilice 0 para no dibujar la base del todo.
//              Alto de base adicional al total del televisor.
//              Default es 40*L.
//      AltoPlacaBase           : Alto de la placa plana inferior de la base.
//              Default es 11*L.
//      TexturaTelevisorApagado : Textura para aplicar a la pantalla apagada.
//              Default es TPPR_TexturaTelevisorApagado.
//      TexturaTelevisorEncendido               : Textura para aplicar sobre
//              la imagen del televisor Encendido.  Deberia tener elevada
//              transparencia.  O bien si lo prefiere, podria tapar
//              completamente la imagen, y sustituirlo por su propio proceso.
//              Default es TPPR_TexturaTelevisorEncendido.
//      TexturaBorde            : Textura principal del televisor, que
//              se aplica al marco.  Default es TPPR_TexturaBorde.
//      TexturaPosterior        : Textura a aplicar a la zona posterior
//              del televisor.  Default es TPPR_TexturaPosterior.
//      MaterialInfrarrojo      : Material a aplicar al lector de infrarrojo.
//              Default es TPPR_MaterialInfrarrojo.
//      MaterialIndicadorEncendido              : Material a aplicar al
//              indicador de encendido.
//              Default es TPPR_MaterialIndicadorEncendido.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare TPPR_SYS               = 0;
//      Selector para TPPR_TipoImagen, corresponde al formato de imagen
//      propio del sistema operativo.
// #declare TPPR_GIF               = 1;
//      Selector para TPPR_TipoImagen, corresponde al tipo GIF.
// #declare TPPR_JPEG              = 2;
//      Selector para TPPR_TipoImagen, corresponde al tipo JPEG.
// #declare TPPR_TGA               = 3;
//      Selector para TPPR_TipoImagen, corresponde al tipo TGA.
// #declare TPPR_PNG               = 4;
//      Selector para TPPR_TipoImagen, corresponde al tipo PNG.
// #declare TPPR_DefaultTexturaTelevisorApagado
//      Textura para aplicar a la pantalla apagada.
// #declare TPPR_DefaultTexturaTelevisorEncendido
//      Textura para aplicar sobre la imagen del televisor encendido.
//      Deberia tener elevada transparencia.  O bien si lo prefiere,
//      podria tapar completamente la imagen, y sustituirlo
//      por su propio proceso.
// #declare TPPR_DefaultTexturaBorde
//      Textura principal del televisor, que se aplica al marco.
// #declare TPPR_DefaultTexturaPosterior
//      Textura a aplicar a la zona posterior del televisor.
// #declare TPPR_DefaultMaterialInfrarrojo
//      Material a aplicar al lector de infrarrojo.
// #declare TPPR_DefaultMaterialIndicadorEncendido
//      Material a aplicar al indicador de encendido.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare TPPR_TipoImagen                             = TPPR_GIF;
//      Para asignar el tipo de imagen a pasar al televisor.
//      Los selectores predefinidos son: TPPR_SYS, TPPR_GIF,
//      TPPR_JPEG, TPPR_TGA y TPPR_PNG.
// #declare TPPR_TexturaTelevisorApagado                = texture  { ... }
//      Textura para aplicar a la pantalla apagada.
// #declare TPPR_TexturaTelevisorEncendido              = texture  { ... }
//      Textura para aplicar sobre la imagen del televisor encendido.
//      Deberia tener elevada transparencia.  O bien si lo prefiere,
//      podria tapar completamente la imagen, y sustituirlo
//      por su propio proceso.
// #declare TPPR_TexturaBorde                           = texture  { ... }
//      Textura principal del televisor, que se aplica al marco.
// #declare TPPR_TexturaPosterior                       = texture  { ... }
//      Textura a aplicar a la zona posterior del televisor.
// #declare TPPR_MaterialInfrarrojo                     = material { ... }
//      Material a aplicar al lector de infrarrojo.
// #declare TPPR_MaterialIndicadorEncendido             = material { ... }
//      Material a aplicar al indicador de encendido.
// #declare HEDA_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "TPPR.inc"
// object        { TPPR_Televisor( on, "custom.gif", 0.005, true ) }
//
// Otro ejemplo con modificador
// #include "TPPR.inc"
// #declare TPPR_TexturaBorde        = texture       {
//   average
//   texture_map        {
//     [ 0.5 TPPR_DefaultTexturaBorde ]
//     [ 0.5 Rust                         ]
//   }
// }
// object        {
//   TPPR_Televisor( on, "custom.gif", 0.005, true )
// }
//
// Un ejemplo con la macro detallada
// #include "TPPR.inc"
// object               {
//   TPPR_TelevisorPlanoPovRay( on, "custom.gif", 0.005,
//        0.350, 0.550, 0.080, 0.027, 0.020,
//        0.014, 0.0043, 0.003, 0.040, 0.011,
//        TPPR_TexturaTelevisorApagado, TPPR_TexturaTelevisorEncendido,
//        TPPR_TexturaBorde, TPPR_TexturaPosterior,
//        TPPR_MaterialInfrarrojo, TPPR_MaterialIndicadorEncendido )
// }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}   
      
light_source    {
         < 500  , 500   , -3000 >*L
         White
} 

background      {
         Gray50
}    

#include "TPPR.inc"
                                   
#declare TPPR_TipoImagen        = TPPR_PNG;                                   
                                   
union                  {
  TPPR_Televisor( on, "povmap.png", 0.005, on )  
  translate     -0.195*y
  translate     -1.75*z
}

