// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 9 Diciembre 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//                      
// ZGON ZanahoriaGeneticamenteOriginalNaturaleza
// El archivo dibuja una zanahoria corriente.
// Muy poco flexible, se incluye en diez variantes.
// La version original de las zanahorias, se desarrollo en Blob Sculptor 2.0b para DOS.
//      
// La siguiente macro dibuja las zanahorias con textura default:
// #macro ZGON_Zanahoria( Selector )
//      Selector                : Permite elegir entre diez estilos de zanahoria.
//              ZGON_Zanahoria1  = 1
//              ZGON_Zanahoria2  = 2
//              ZGON_Zanahoria3  = 3
//              ZGON_Zanahoria4  = 4
//              ZGON_Zanahoria5  = 5
//              ZGON_Zanahoria6  = 6
//              ZGON_Zanahoria7  = 7
//              ZGON_Zanahoria8  = 8
//              ZGON_Zanahoria9  = 9
//              ZGON_Zanahoria10 = 10
//   
// Las dimensiones de las zanahorias son algo irregulares :
//      Largo Y                 : 125*L muy variable
//      Radio                   :  10*L muy variable
//      Punto Maximo Y          :   5*L variable  
// El objeto se orienta en el Eje Y, gravedad Y-.
//              
// La siguiente macro permite modificar las texturas:
// #macro ZGON_ZanahoriaGeneticamenteOriginalNaturaleza
//              ( Selector, TexturaZanahoria, TexturaTallo )
//      Selector                : Permite elegir entre diez estilos de zanahoria.
//              ZGON_Zanahoria1  = 1
//              ZGON_Zanahoria2  = 2
//              ZGON_Zanahoria3  = 3
//              ZGON_Zanahoria4  = 4
//              ZGON_Zanahoria5  = 5
//              ZGON_Zanahoria6  = 6
//              ZGON_Zanahoria7  = 7
//              ZGON_Zanahoria8  = 8
//              ZGON_Zanahoria9  = 9
//              ZGON_Zanahoria10 = 10
//      TexturaZanahoria        : Textura principal de la zanahoria.
//      TexturaTallo            : Textura a aplicar al tallito.
//                                                     
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse.
// #declare ZGON_DefaultTexturaZanahoria         
//      Textura principal de la zanahoria.
// #declare ZGON_DefaultTexturaTallo       
//      Textura del tallito.
//   
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare ZGON_TexturaZanahoria                       = texture { ... }
//      Textura principal de la zanahoria.
// #declare ZGON_TexturaTallo                           = texture { ... }     
//      Textura del tallito.
// #declare ZGON_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
//
// Para colocarlo simplemente
//
// #include "ZGON.inc"
// object                  {
//   ZGON_Zanahoria( ZGON_Zanahoria1 ) 
// }
//
// o bien la misma figura anterior con macro detallada 
// #include "ZGON.inc"
// object                  {  
//   ZGON_ZanahoriaGeneticamenteOriginalNaturaleza
//              ( ZGON_Zanahoria1, PinkAlabaster, PinkAlabaster ) 
// }
//   
// o bien los modificadores
// #include "EBPH.inc"
// #declare ZGON_TexturaZanahoria = PinkAlabster
// object               { 
//   ZGON_Zanahoria( ZGON_Zanahoria1 )
// } 
//
#include "stones.inc"          
#include "woods.inc"
#declare ZGON_L                         = 0.001;
#declare ZGON_Zanahoria1                = 1;
#declare ZGON_Zanahoria2                = 2;
#declare ZGON_Zanahoria3                = 3;
#declare ZGON_Zanahoria4                = 4;
#declare ZGON_Zanahoria5                = 5;
#declare ZGON_Zanahoria6                = 6;
#declare ZGON_Zanahoria7                = 7;
#declare ZGON_Zanahoria8                = 8;
#declare ZGON_Zanahoria9                = 9;
#declare ZGON_Zanahoria10               = 10;
                                         
#declare ZGON_Textura1                  =                                         
  texture                       {
    T_Wood29       
    translate   10
    scale       0.5
  }    
  
#declare ZGON_Textura2                  =
  texture                       {     
    T_Grnt29
    scale       0.1
  }

#declare ZGON_Textura3                  =
  texture                       { 
    pigment                     {
      gradient          y   
      scale             0.01    
      turbulence        0.5
      pigment_map               { 
        [ 0.0 Orange*2 ]  
        [ 0.050 IndianRed       ]
        [ 0.1 Orange*2 ]                     
      }
    }
  }
                                         
#declare ZGON_DefaultTexturaZanahoria   =
  texture                       { 
    average
    texture_map                 { 
      [ 0.3 ZGON_Textura1 ]
      [ 0.3 ZGON_Textura2 ]
      [ 0.4 ZGON_Textura3 ]
    }
  }
   
#ifndef ( ZGON_TexturaZanahoria )   
  #declare ZGON_TexturaZanahoria        = texture { ZGON_DefaultTexturaZanahoria }
#end  

#declare ZGON_DefaultTexturaTallo       =
  texture                       {
    pigment             { 
      onion     
      scale 0.5  
      turbulence        0.3
      pigment_map                 {  
        [0.5 DarkOliveGreen ]
        [0.5 MediumSpringGreen ]
        [0.9 MidnightBlue ]
        [0.9 DarkBrown ]
      }                 
    } 
    normal              {  
      agate  
      scale             0.01
    }
  }
  texture               {    
    pigment             {    
      agate
      pigment_map               { 
        [ 0 color Wheat transmit 0.5 ]
        [ 1 color DarkWood transmit 0.5 ]
      }
    }               
    
  }
  
#ifndef ( ZGON_TexturaTallo )   
  #declare ZGON_TexturaTallo            = texture { ZGON_DefaultTexturaTallo }
#end        


#macro ZGON_ZanahoriaGeneticamenteOriginalNaturaleza( Selector, TexturaZanahoria, TexturaTallo )
  union                         {
    #declare L                  = ZGON_L;
    union                      {
    #switch( Selector )
      #case ( ZGON_Zanahoria1 )
blob {
   threshold 0.6
   component 1.000000, 0.686572, <0.042194, 0.000000, -0.025316>
   component 1.000000, 0.763277, <-0.025316, 0.000000, -0.177215>
   component 1.000000, 1.380236, <0.075949, 0.000000, -0.784810>
   component 1.000000, 1.531740, <0.025316, 0.000000, -1.341772>
   component 1.000000, 1.413000, <-0.061808, 0.000000, -2.369297>
   component 1.000000, 1.504257, <0.020603, 0.000000, -1.833630>
   component 1.000000, 1.602877, <-0.226628, 0.000000, -3.193401>
   component 1.000000, 0.970346, <-0.020603, 0.000000, -2.863759>
   component 1.000000, 1.097821, <-0.226628, 0.000000, -3.811478>
   component 1.000000, 1.198634, <-0.281676, 0.000000, -4.788491>
   component 1.000000, 1.198634, <-0.362155, 0.000000, -4.386097>
   component 1.000000, 0.912853, <0.040239, 0.000000, -5.512801>
   component 1.000000, 0.611186, <0.120718, 0.000000, -6.237111> 
   #declare FactorTextura       = 0*x;
   #declare FactorRotateTextura = 0; 
   #declare FactorEscaleTextura = 1;
} 
superellipsoid                  {    
  < 1.0, 0.7 >              
  texture                       {  
    TexturaTallo            
    translate   z   
  }
  scale         <0.30,0.30,0.15>
  rotate        10
  translate     +0.3*z 
}
      #break
      #case ( ZGON_Zanahoria2 )
blob {
   threshold 0.6
   component 1.000000, 0.508989, <0.025316, 0.000000, -0.008439>
   component 1.000000, 0.524880, <0.025316, 0.000000, -0.261603>
   component 1.000000, 0.842777, <0.008439, 0.000000, -0.531646>
   component 1.000000, 0.850062, <0.008439, 0.000000, -0.835443>
   component 1.000000, 0.699684, <-0.008439, 0.000000, -1.021097>
   component 1.000000, 0.964488, <-0.025316, 0.000000, -1.308017>
   component 1.000000, 1.168451, <0.025753, 0.000000, -1.570947>
   component 1.000000, 0.898605, <-0.008439, 0.000000, -1.831224>
   component 1.000000, 1.124769, <-0.016482, 0.000000, -2.159151>
   component 1.000000, 0.790132, <-0.016482, 0.000000, -2.422864>
   component 1.000000, 0.898569, <-0.016482, 0.000000, -2.719541>
   component 1.000000, 0.894615, <-0.025753, 0.000000, -3.116141>
   component 1.000000, 0.759416, <0.025753, 0.000000, -3.476686>
   component 1.000000, 0.542440, <0.077260, 0.000000, -3.940244>
   component 1.000000, 0.542439, <0.025753, 0.000000, -4.300789>
   component 1.000000, 0.343068, <0.025753, 0.000000, -4.661335>
   #declare FactorTextura       = 10*y+0.1*x; 
   #declare FactorRotateTextura = 0; 
   #declare FactorEscaleTextura = 0.9;
}      
superellipsoid                  {    
  < 1.0, 0.7 >              
  texture                       {  
    TexturaTallo            
    translate   z   
  }
  scale         0.75*<0.30,0.30,0.15>
  rotate        10
  translate     +0.15*z 
}
      #break
      #case ( ZGON_Zanahoria3 )
blob {
   threshold 0.6
   component 1.000000, 0.452469, <0.042194, 0.000000, -0.025316>
   component 1.000000, 0.384525, <0.160338, 0.000000, -1.139241>
   component 1.000000, 0.555458, <-0.065928, 0.000000, -0.276899>
   component 1.000000, 0.590460, <-0.118671, 0.000000, -0.593354>
   component 1.000000, 0.404380, <-0.092300, 0.000000, -0.962553>
   component 1.000000, 0.555458, <0.171413, 0.000000, -1.358122>
   component 1.000000, 0.722096, <0.039557, 0.000000, -1.674578>
   component 1.000000, 0.547063, <-0.145042, 0.000000, -1.991034>
   component 1.000000, 0.668861, <-0.250527, 0.000000, -2.228375>
   component 1.000000, 0.589153, <-0.296677, 0.000000, -2.670095>
   component 1.000000, 0.444583, <-0.362605, 0.000000, -3.065665>
   component 1.000000, 0.373904, <-0.395570, 0.000000, -3.296414>
   #declare FactorTextura       = 20*y+0.1*x; 
   #declare FactorRotateTextura = 0; 
   #declare FactorEscaleTextura = 0.9;
}
superellipsoid                  {    
  < 1.0, 0.7 >              
  texture                       {  
    TexturaTallo            
    translate   z   
  }
  scale         0.75*<0.30,0.30,0.15>
  rotate        70
  translate     +0.10*z 
}
      #break
      #case ( ZGON_Zanahoria4 )
blob {
   threshold 0.6
   component 1.000000, 0.650928, <-0.077260, 0.000000, -0.077260>
   component 1.000000, 0.216976, <-0.901363, 0.000000, -4.712841>
   component 1.000000, 0.460276, <-0.798350, 0.000000, -4.352296>
   component 1.000000, 0.686138, <-0.489311, 0.000000, -3.682712>
   component 1.000000, 0.874658, <-0.180273, 0.000000, -2.704089>
   component 1.000000, 0.782318, <-0.128766, 0.000000, -3.116141>
   component 1.000000, 0.926922, <-0.128766, 0.000000, -1.622454>
   component 1.000000, 0.874658, <-0.180273, 0.000000, -0.592324>
   component 1.000000, 1.068483, <-0.180273, 0.000000, -1.158895>
   component 1.000000, 0.867904, <-0.180273, 0.000000, -2.189025>
   component 1.000000, 0.789804, <-0.643831, 0.000000, -4.043257>
   component 1.000000, 0.894615, <-0.334792, 0.000000, -3.425180>
   #declare FactorTextura       = 5*y+0.1*x; 
   #declare FactorRotateTextura = 10; 
   #declare FactorEscaleTextura = 0.7;
}
superellipsoid                  {    
  < 1.0, 0.7 >              
  texture                       {  
    TexturaTallo            
    translate   z   
  }
  scale         0.75*<0.30,0.30,0.15>
  rotate        10
  translate     +0.15*z 
}
      #break
      #case ( ZGON_Zanahoria5 )
blob {
   threshold 0.6
   component 1.000000, 0.800168, <-0.020603, 0.000000, -0.061808>
   component 1.000000, 0.906118, <-0.103013, 0.000000, -0.638680>
   component 1.000000, 1.059411, <-0.144218, 0.000000, -1.174347>
   component 1.000000, 1.290232, <-0.103013, 0.000000, -1.668809>
   component 1.000000, 1.180477, <-0.103013, 0.000000, -2.245682>
   component 1.000000, 1.087480, <-0.103013, 0.000000, -2.781349>
   component 1.000000, 1.093322, <-0.160958, 0.000000, -3.315728>
   component 1.000000, 1.093322, <-0.160958, 0.000000, -3.702027>
   component 1.000000, 0.559135, <-0.225341, 0.000000, -4.410241>
   #declare FactorTextura       = -5*y+0.1*x; 
   #declare FactorRotateTextura = 1; 
   #declare FactorEscaleTextura = 0.3;
}
superellipsoid                  {    
  < 1.0, 0.7 >              
  texture                       {  
    TexturaTallo            
    translate   z   
  }
  scale         1.00*<0.30,0.30,0.15>
  rotate        -2
  translate     +0.17*z 
}
      #break
      #case ( ZGON_Zanahoria6 )
blob {
   threshold 0.6
   component 1.000000, 0.467380, <0.061808, 0.000000, -0.061808>
   component 1.000000, 0.506070, <-0.061808, 0.000000, -0.309039>
   component 1.000000, 0.506070, <-0.061808, 0.000000, -0.597475>
   component 1.000000, 0.506070, <-0.061808, 0.000000, -0.844706>
   component 1.000000, 0.506070, <-0.061808, 0.000000, -1.009527>
   component 1.000000, 0.506070, <-0.061808, 0.000000, -1.215552>
   component 1.000000, 0.506070, <-0.103013, 0.000000, -1.462783>
   component 1.000000, 0.506070, <-0.144218, 0.000000, -1.668809>
   component 1.000000, 0.506070, <-0.103013, 0.000000, -1.874835>
   component 1.000000, 0.506070, <-0.103013, 0.000000, -2.080861>
   component 1.000000, 0.506070, <-0.144218, 0.000000, -2.245682>
   component 1.000000, 0.506070, <-0.185423, 0.000000, -2.451708>
   component 1.000000, 0.506070, <-0.144218, 0.000000, -2.534118>
   component 1.000000, 0.506070, <-0.144218, 0.000000, -2.781349>
   component 1.000000, 0.506070, <-0.185423, 0.000000, -3.069785>
   component 1.000000, 0.506070, <-0.144218, 0.000000, -3.234606>
   component 1.000000, 0.506070, <-0.144218, 0.000000, -3.399426>
   component 1.000000, 0.245480, <-0.103013, 0.000000, -3.687863>
   #declare FactorTextura       = -15*y+0.1*x; 
   #declare FactorRotateTextura = 5; 
   #declare FactorEscaleTextura = 1;
}
superellipsoid                  {    
  < 1.0, 0.7 >              
  texture                       {  
    TexturaTallo            
    translate   z   
  }
  scale         0.50*<0.30,0.30,0.45>
  rotate        10
  translate     +0.075*z 
}
      #break
      #case ( ZGON_Zanahoria7 )
blob {
   threshold 0.6
   component 1.000000, 0.597279, <-0.016482, 0.000000, -0.115374>
   component 1.000000, 0.776277, <-0.115374, 0.000000, -0.477980>
   component 1.000000, 0.347161, <0.412052, 0.000000, -0.148339>
   component 1.000000, 0.444584, <0.477980, 0.000000, -0.477980>
   component 1.000000, 0.542284, <0.280195, 0.000000, -0.807621>
   component 1.000000, 0.883729, <-0.280195, 0.025316, -1.088608>
   component 1.000000, 0.724895, <-0.280195, 0.177215, -1.476793>
   component 1.000000, 0.751025, <-0.247231, 0.148339, -1.796545>
   component 1.000000, 0.763755, <-0.214267, 0.115374, -2.225079>
   component 1.000000, 0.559781, <-0.148339, 0.181303, -2.620649>
   #declare FactorTextura       = -25*y+0.1*x; 
   #declare FactorRotateTextura = 5; 
   #declare FactorEscaleTextura = 1;
}
superellipsoid                  {    
  < 1.0, 0.7 >              
  texture                       {  
    TexturaTallo            
    translate   z   
  }
  scale         0.75*<0.30,0.30,0.15>
  rotate        10
  translate     +0.075*z 
}
superellipsoid                  {    
  < 1.0, 0.7 >              
  texture                       {  
    TexturaTallo            
    translate   z   
  }
  scale         0.35*<0.30,0.30,0.15>
  rotate        -10
  translate     +0.055*z+0.40*x 
}
      #break
      #case ( ZGON_Zanahoria8 )
blob {
   threshold 0.6
   component 1.000000, 1.358484, <0.020603, 0.000000, -0.061808>
   component 1.000000, 1.263687, <-0.020603, 0.000000, -0.473859>
   component 1.000000, 1.131608, <-0.061808, 0.000000, -1.050732>
   component 1.000000, 0.934761, <-0.144218, 0.000000, -1.545194>
   component 1.000000, 0.854786, <0.000000, 0.020603, -1.916040>
   component 1.000000, 0.818779, <0.000000, 0.061808, -2.369297>
   component 1.000000, 0.922594, <0.000000, -0.020603, -2.781349>
   component 1.000000, 0.823366, <0.000000, -0.144218, -3.193401>
   component 1.000000, 0.785920, <0.000000, 0.020603, -3.646657>
   component 1.000000, 0.625854, <0.000000, 0.103013, -4.099914>
   #declare FactorTextura       = -30*y+0.2*z; 
   #declare FactorRotateTextura = 0; 
   #declare FactorEscaleTextura = 0.5;
}
superellipsoid                  {    
  < 1.0, 0.7 >              
  texture                       {  
    TexturaTallo            
    translate   z   
  }
  scale         1.25*<0.30,0.30,0.15>
  rotate        5
  translate     +0.4750*z 
}
      #break
      #case ( ZGON_Zanahoria9 )
blob {
   threshold 0.6
   component 1.000000, 0.305807, <-0.042194, 0.000000, -0.025316>
   component 1.000000, 0.301646, <-0.160338, 0.000000, -0.160338>
   component 1.000000, 0.303734, <-0.042194, 0.000000, -0.362869>
   component 1.000000, 0.377895, <0.092827, -0.109705, -0.497890>
   component 1.000000, 0.537959, <0.000000, 0.075949, -0.734177>
   component 1.000000, 0.607467, <0.008439, 0.109705, -0.801688>
   component 1.000000, 0.462141, <0.160338, 0.000000, -1.122363>
   component 1.000000, 0.428071, <0.000000, -0.329114, -1.274262>
   component 1.000000, 0.227627, <0.000000, -0.464135, -1.510548>
   #declare FactorTextura       = -35*y+0.2*x; 
   #declare FactorRotateTextura = -20; 
   #declare FactorEscaleTextura = 0.25;
}
superellipsoid                  {    
  < 1.0, 0.7 >              
  texture                       {  
    TexturaTallo            
    translate   z   
  }
  scale         0.50*<0.30,0.40,0.15>
  rotate        +45  
  rotate        80*z
  translate     -0.20*z-0.00*x+0.10*y
}
      #break
      #case ( ZGON_Zanahoria10 )
blob {
   threshold 0.6
   component 1.000000, 0.277649, <0.396624, 0.000000, -0.059072>
   component 1.000000, 0.384525, <-0.312236, 0.000000, -0.042194>
   component 1.000000, 0.433935, <-0.210970, 0.000000, -0.261603>
   component 1.000000, 0.392655, <0.278481, 0.000000, -0.194093>
   component 1.000000, 0.541471, <0.042194, 0.000000, -0.514768>
   component 1.000000, 0.578701, <0.059072, 0.000000, -0.869198>
   component 1.000000, 0.543800, <0.000000, -0.126582, -1.105485>
   component 1.000000, 0.603292, <0.000000, -0.194093, -1.392405>
   component 1.000000, 0.566459, <0.000000, -0.171413, -1.753692>
   component 1.000000, 0.447825, <0.000000, -0.250527, -2.017405>
   component 1.000000, 0.392768, <0.000000, -0.197785, -2.202004>
   component 1.000000, 0.388821, <0.000000, -0.197785, -2.412975>
   component 1.000000, 0.337872, <0.000000, -0.197785, -2.703059>
   component 1.000000, 0.333275, <0.000000, -0.092300, -2.887658>
   component 1.000000, 0.166638, <0.000000, 0.013186, -3.125000>
   #declare FactorTextura       = -20*y+0.05*z; 
   #declare FactorRotateTextura = 0; 
   #declare FactorEscaleTextura = 1;
}
superellipsoid                  {    
  < 1.0, 0.7 >              
  texture                       {  
    TexturaTallo            
    translate   z   
  }
  scale         0.35*<0.30,0.30,0.15>
  rotate        10   
  rotate        -45*y
  translate     +0.075*z-0.40*x 
}
superellipsoid                  {    
  < 1.0, 0.7 >              
  texture                       {  
    TexturaTallo            
    translate   z   
  }
  scale         0.25*<0.30,0.30,0.15>
  rotate        10   
  rotate        -10*y
  translate     +0.075*z-0.40*x+0.80*x 
}
      #break
      #else
        #error "Selector de Zanahoria fuera de rango..."
      #break
    #end  // #macro ZGON_Zanahoria1
      scale       1/4  
      scale       100*L
      rotate      -90*x
      texture                   {  
        TexturaZanahoria  
        scale           FactorEscaleTextura
        rotate          FactorRotateTextura
        translate       FactorTextura
      }  
    } 
 
  }
#end  // #macro ZGON_ZanahoriaGeneticamenteOriginalNaturaleza

#macro ZGON_Zanahoria( Selector )
  object                        {
    ZGON_ZanahoriaGeneticamenteOriginalNaturaleza( Selector, ZGON_TexturaZanahoria,
       ZGON_TexturaTallo )
  }
#end
